<!--Header-->


<!doctype html>
<html class="no-js" lang="<?php echo config_item('ca_html_lang'); ?>">

<head>
  <meta charset="utf-8">
  <meta http-equiv="x-ua-compatible" content="ie=edge">
  <title><?php echo $data['page']['meta_title']; ?></title>
  <meta name="description" content="<?php echo $data['page']['meta_description']; ?>">
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

  <base href="<?php echo $this->config->item('base_url'); ?>/">

  <link rel="manifest" href="site.webmanifest">
  <link rel="apple-touch-icon" href="img/apple-touch-icon.png">
  <link rel="icon" href="favicon.ico" type="image/x-icon">
  <link href="https://fonts.googleapis.com/css2?family=Playfair+Display:ital@1&family=Source+Sans+Pro:wght@400;600&display=swap" rel="stylesheet">
  <link rel="stylesheet" href="css/plugins.min.css">
  <link rel="stylesheet" href="css/main.min.css">

    <?php if (!empty(config_item('ca_g_analytics'))) { ?>
    <!-- Global site tag (gtag.js) - Google Analytics -->
    <script async src="https://www.googletagmanager.com/gtag/js?id=<?php echo config_item('ca_g_analytics')['tracking_id']; ?>"></script>
    <script>
      window.dataLayer = window.dataLayer || [];
      function gtag(){dataLayer.push(arguments);}
      gtag('js', new Date());
      gtag('config', '<?php echo config_item('ca_g_analytics')['tracking_id']; ?>');
    </script>
  <?php } ?>

  <!--Facebook Pixel Code-->
  <script>
    !function(f,b,e,v,n,t,s)
    {if(f.fbq)return;n=f.fbq=function(){n.callMethod?
    n.callMethod.apply(n,arguments):n.queue.push(arguments)};
    if(!f._fbq)f._fbq=n;n.push=n;n.loaded=!0;n.version='2.0';
    n.queue=[];t=b.createElement(e);t.async=!0;
    t.src=v;s=b.getElementsByTagName(e)[0];
    s.parentNode.insertBefore(t,s)}(window, document,'script',
    'https://connect.facebook.net/en_US/fbevents.js');
    fbq('init', '4983916534969527');
    fbq('track', 'PageView');
  </script>
  <noscript><img height="1" width="1" style="display:none"
    src="https://www.facebook.com/tr?id=4983916534969527&ev=PageView&noscript=1"
  /></noscript>
  <!--End Facebook Pixel Code-->

</head>

<body id="page-<?php echo friendly_string_get($data['page']['slug']); ?>">

    <input type="checkbox" id="check-notification-toggle" name="check-notification-toggle" class="check-notification hidden">
    <div class="notification fade clearfix <?php echo $data['notification']['type']; ?>"><?php
        if (!empty($data['notification']['message'])) {
          echo $data['notification']['message'];
          echo '<label for="check-notification-toggle" id="label-notification-toggle" class="float-r">Cerrar</label>';
        }
      ?></div>

  <header>
    <div class="container boxed align-c header-logo-wrapper">
      <a href="<?php echo base_url(config_item('ca_lang')); ?>" title="" class="logo no-decoration">
        <img src="img/header-logo<?php if('inicio' != $data['params'][0]) { echo '-alt'; }; ?>.svg" title="" alt="" class="header-logo">
      </a>
    </div>

    <?php if ('inicio' == $data['params'][0]) { ?>
      <div class="container boxed">
        <div class="socialmedia-links">
          <a href="https://www.facebook.com/yeguadalareservaofficial/" title="" class="no-decoration base" target="_blank"><i class="fab fa-facebook-f"></i></a>
          <br /><br />
          <a href="https://www.instagram.com/yeguadalareserva/" title="" class="no-decoration base" target="_blank"><i class="fab fa-instagram"></i></a>
          <br /><br />
          <a href="https://www.youtube.com/channel/UCvvrIXNohY1l3lNMx6g48uw/videos" title="" class="no-decoration base" target="_blank"><i class="fab fa-youtube"></i></a>
          <br /><br />
          <a href="https://www.tiktok.com/@yeguadalareservaofficial" title="" class="no-decoration base" target="_blank"><i class="fab fa-tiktok"></i></a>
          <br /><br />
          <a href="https://twitter.com/yeguadareserva_" title="" class="no-decoration base" target="_blank"><i class="fab fa-twitter"></i></a>
        </div>
      </div>
    <?php } ?>

    <div id="navigation" class="container boxed clearfix">

      <input type="checkbox" id="check_mobile_menu_toggle" name="check_mobile_menu_toggle" class="hidden">
      <label for="check_mobile_menu_toggle" id="label_mobile_menu_toggle" class="hidden" aria-label="Menu"></label>

      <div class="navigation slide-l main align-r">
        <input type="checkbox" id="check-menu-toggle" name="check-menu-toggle" class="check-menu-toggle hidden">
        <label for="check-menu-toggle" id="label-menu-toggle" class="label-menu-toggle"><div></div></label>
        <nav class="menu">
          <div class="align-r"><label for="check-menu-toggle" class="label-menu-toggle-close"><i class="fas fa-lg fa-times"></i></label></div>
          <div class="align-l">
            <a href="<?php echo base_url(config_item('ca_lang') . '/inicio'); ?>" title="" class="no-decoration white main<?php if ('inicio' == $data['params'][0] || is_null($data['params'][0])) { echo ' active'; } ?>">Home</a>
            <a href="<?php echo base_url(config_item('ca_lang') . '/quienes-somos'); ?>" title="" class="no-decoration white main<?php if ('quienes-somos' == $data['params'][0]) { echo ' active'; } ?>">Quiénes somos</a>
            <a href="<?php echo base_url(config_item('ca_lang') . '/catalogo'); ?>" title="" class="no-decoration white main<?php if ('catalogo' == $data['params'][0]) { echo ' active'; } ?>">Productos</a>
            <a href="<?php echo base_url(config_item('ca_lang') . '/distribuidores'); ?>" title="" class="no-decoration white main<?php if ('distribuidores' == $data['params'][0]) { echo ' active'; } ?>">Distribuidores</a>
            <a href="<?php echo base_url(config_item('ca_lang') . '/preguntas-frecuentes'); ?>" title="" class="no-decoration white main<?php if ('preguntas-frecuentes' == $data['params'][0]) { echo ' active'; } ?>">Preguntas frecuentes</a>
            <a href="<?php echo base_url(config_item('ca_lang') . '/contacto'); ?>" title="" class="no-decoration white main<?php if ('contacto' == $data['params'][0]) { echo ' active'; } ?>">Quiero ser distribuidor</a>
          </div>
        </nav>
      </div>

    </div>

  </header>


  <main id="" class="">


  <!--/Header-->
  <!--Content-->