<?php
defined('BASEPATH') OR exit('No direct script access allowed');

/*
| -------------------------------------------------------------------------
| URI ROUTING
| -------------------------------------------------------------------------
| This file lets you re-map URI requests to specific controller functions.
|
| Typically there is a one-to-one relationship between a URL string
| and its corresponding controller class/method. The segments in a
| URL normally follow this pattern:
|
|	example.com/class/method/id/
|
| In some instances, however, you may want to remap this relationship
| so that a different class/function is called than the one
| corresponding to the URL.
|
| Please see the user guide for complete details:
|
|	https://codeigniter.com/user_guide/general/routing.html
|
| -------------------------------------------------------------------------
| RESERVED ROUTES
| -------------------------------------------------------------------------
|
| There are three reserved routes:
|
|	$route['default_controller'] = 'welcome';
|
| This route indicates which controller class should be loaded if the
| URI contains no data. In the above example, the "welcome" class
| would be loaded.
|
|	$route['404_override'] = 'errors/page_missing';
|
| This route will tell the Router which controller/method to use if those
| provided in the URL cannot be matched to a valid route.
|
|	$route['translate_uri_dashes'] = FALSE;
|
| This is not exactly a route, but allows you to automatically route
| controller and method names that contain dashes. '-' isn't a valid
| class or method name character, so it requires translation.
| When you set this option to TRUE, it will replace ALL dashes in the
| controller and method URI segments.
|
| Examples:	my-controller/index	-> my_controller/index
|		my-controller/my-method	-> my_controller/my_method
*/

/**
 * Content Assistant
 * Project routes
 *
 * AC path conditional
 * Default controller
 * CA Setup
 * CA POST requests
 * CA Pages
 * 
 */
/* AC path conditional */
$this->config->load('ca_config');
$ac_path = config_item('ca_ac_path');
$ac_controller_prefix = null;
if ($this->uri->segment(1) == $ac_path OR 
		$this->uri->segment(2) == $ac_path) {
	$ac_controller_prefix = 'ac_';
}
/* Default controller */
$route['default_controller'] = 'Ca_' . $ac_controller_prefix . 'pages';

/* CA Setup */
$route['ca/setup'] = 'Ca_migrations';
$route['ca/setup/do']['POST'] = 'Ca_migrations/do';

/* CA POST requests */
$route['(:any)?']['POST'] = 'Ca_' . $ac_controller_prefix . 'requests/index/$1';
$route['(:any)/(:any)?']['POST'] = 'Ca_' . $ac_controller_prefix . 'requests/index/$1/$2';
$route['(:any)/(:any)/(:any)?']['POST'] = 'Ca_' . $ac_controller_prefix . 'requests/index/$1/$2/$3';
$route['(:any)/(:any)/(:any)/(:any)?']['POST'] = 'Ca_' . $ac_controller_prefix . 'requests/index/$1/$2/$3/$4';
$route['(:any)/(:any)/(:any)/(:any)/(:any)?']['POST'] = 'Ca_' . $ac_controller_prefix . 'requests/index/$1/$2/$3/$4/$5';

/* CA Pages */
$route['(:any)?']['GET'] ='Ca_' . $ac_controller_prefix . 'pages/index/$1';
$route['(:any)/(:any)?']['GET'] = 'Ca_' . $ac_controller_prefix . 'pages/index/$1/$2';
$route['(:any)/(:any)/(:any)?']['GET'] = 'Ca_' . $ac_controller_prefix . 'pages/index/$1/$2/$3';
$route['(:any)/(:any)/(:any)/(:any)?']['GET'] = 'Ca_' . $ac_controller_prefix . 'pages/index/$1/$2/$3/$4';
$route['(:any)/(:any)/(:any)/(:any)/(:any)?']['GET'] = 'Ca_' . $ac_controller_prefix . 'pages/index/$1/$2/$3/$4/$5';


$route['404_override'] = '';
$route['translate_uri_dashes'] = FALSE;