<?php
	defined('BASEPATH') OR exit('No direct script access allowed');
	/**
	 * Content Assistant
	 *
	 * A kind of Headless CMS system build over the Codeigniter framework (http://codeigniter.com)
	 *
	 * @package   ContentAssistant
	 * @author    A59327424 @ Codeinalab
	 * @copyright 
	 * @license   
	 * @link      
	 * @version   0.10.0
	 */

  /**
   * Ca_ac_pages controller
   *
   * [Description]
   *
   * @todo
   */
	class Ca_ac_pages extends CI_Controller
	{


	/**
	 * index
	 *
	 * Default function, this will 
	 * catch all url GET requests
	 * check for authentication
	 * get 
	 * default page info 
	 * additional data 
	 * or notification
	 * and then will load view
	 *
	 * @param  string $param_1 section or language
	 * @param  string $param_2 section, subsection or param
	 * @param  mixed $param_3 optional
	 * @param  mixed $param_4 optional
	 * @param  mixed $param_5 optional
	 *
	 * @return [type] [description]
	 */
	public function index($param_1 = null, 
												$param_2 = null,
												$param_3 = null,
												$param_4 = null,
												$param_5 = null,
												$param_6 = null)
	{
		// Create an array with url params (segments)
		$params = array_pad(func_get_args(), 6, null);
		// First url param can be an available language code eg. es-mx
		// Remove from array if it is
		// language is previously defined by the language model
		// and accessed using config_item
		$avaliable_languages = $this->ca_utility->settings_get(null, 'languages')[0];
		if (in_array($params[0], array_column($avaliable_languages['items'], 'value')))
		{
			array_shift($params);
		}
		if (is_null($params[1]))
		{
			$params[1] = 'inicio';
		}
		$data = [];
		/* Auth */
		$data['data']['auth']['session'] = $this->ca_authentication->check();
		if (!empty($data['data']['auth']['session'])) {
			$f_project_name = friendly_string_get($this->ca_utility->settings_get(null, 'project')[0]['items']['name']['value']);
		  $data['data']['user'] = $this->ca_user->get($this->encryption->decrypt($_SESSION[$f_project_name . '_data']['user_id']))[0];
		}
		/* Page */
		$data['data']['params'] = $params;
		$id = $this->ca_page->id_by_slug_get($params, null);
		$data['data']['page'] = $this->ca_page->get($id, null, false, false, null, 1)[0];
		$data['data']['page']['is_ac'] = true;
		/* Additional data */
		$additional_data = $this->_ac_additional_data_get($params);
		$data = array_replace_recursive($data, $additional_data);
		/* Notification */
		$data['data']['notification'] = array('type' => '', 'message' => '');
		if ($this->session->flashdata('notification')) {
			$data['data']['notification'] = $this->session->flashdata('notification');
		}
		/* Load view */
		$this->_ac_load_view($data);
	}


	private function _ac_load_view($data)
	{
		$header = 'ca_ac_partials_header';
		$footer = 'ca_ac_partials_footer';
		$ac_path = config_item('ca_ac_path') . '/';
		if ('404' == $data['data']['page']['slug']) {
			$this->output->set_status_header('404');
		}
		$this->load->view($ac_path . $header . '.php', $data);
		$this->load->view($ac_path . $data['data']['page']['template']);
		$this->load->view($ac_path . $footer . '.php');
	}


	private function _ac_additional_data_get($params)
  {
  	$additional_data = [];
  	$additional_data['data']['project'] = $this->ca_utility->settings_get(null, 'project')[0];
  	//* $params[0] is ac
  	switch($params[1]) {
			case 'usuarios':
				$additional_data['data']['users'] = $this->ca_user->get($params[3]);
				$additional_data['data']['auth_roles'] = $this->ca_utility->settings_get(null, 'auth_roles')[0];
				break;
			case 'configuracion':
				$additional_data['data']['settings'] = $this->ca_utility->settings_get(null, null);
				if (!empty($params[3])) {
					$additional_data['data']['item'] = $this->ca_utility->settings_get($params[3], null);
				}
				break;
			case 'categorias':
				$additional_data['data']['categories'] = $this->ca_page->category_get(null, null, null, null);
				if (!empty($params[3])) {
					$additional_data['data']['item'] = $this->ca_page->category_get($params[3], null, null, null);
				}
				break;
			case 'paginas':
				//* Get categories and filter page categories
				$categories = $this->ca_page->category_get(null, null, null, 1);
				$categories = array_values(array_filter($categories, function($arr)
				{
					return preg_match('/^[1.]/', $arr['parents_path']);
				}));
				$pages_categories_id = array_column($categories, 'id');
				//* Get pages and filter by page categories
				$pages = $this->ca_page->get(null, null, null, null, null, null);
				$pages = array_values(array_filter($pages, function($arr) use ($pages_categories_id)
				{
					return in_array($arr['category_id'], $pages_categories_id);
				}));
				$additional_data['data']['pages'] = $pages;
				$additional_data['data']['categories'] = $categories;

				$additional_data['data']['templates'] = $this->ca_utility->settings_get(null, 'templates')[0]['items'];

				$additional_data['data']['image_sizes'] = $this->ca_utility->settings_get(null, 'pages_image_sizes')[0]['items']['default']['value'];
				$additional_data['data']['additional_fields'] = $this->ca_utility->settings_get(null, 'pages_additional_fields')[0];
				
				if (!empty($params[3])) {
					$item_id = $params[3];
					$additional_data['data']['item'] = $this->ca_page->get($item_id, null, null, false, null, null);
					$images = $this->ca_utility->folder_files_get('pages', $item_id . '_', 'jpg|png');
					$additional_data['data']['additional_images'] = $images;
					
				}

				break;
			case 'posts':
				//* Get categories and filter post categories
				$categories = $this->ca_page->category_get(null, null, null, 1);
				$categories = array_values(array_filter($categories, function($arr)
				{
					return preg_match('/^[2.]/', $arr['parents_path']);
				}));
				$posts_categories_id = array_column($categories, 'id');
				//* Get pages and filter by page categories
				$posts = $this->ca_page->get(null, null, null, null, null, null);
				$posts = array_values(array_filter($posts, function($arr) use ($posts_categories_id)
				{
					return in_array($arr['category_id'], $posts_categories_id);
				}));
				$additional_data['data']['posts'] = $posts;
				$additional_data['data']['categories'] = $categories;

				$additional_data['data']['templates'] = $this->ca_utility->settings_get(null, 'templates')[0]['items'];

				$additional_data['data']['image_sizes'] = $this->ca_utility->settings_get(null, 'pages_image_sizes')[0]['items']['default']['value'];
				$additional_data['data']['additional_fields'] = $this->ca_utility->settings_get(null, 'posts_additional_fields')[0];

				if (!empty($params[3])) {
					$additional_data['data']['item'] = $this->ca_page->get($params[3], null, null, false, null, null);
					//* @todo get blog id by slig/alias as id can change if a new page is added
					//$additional_data['data']['pages'] = $this->ca_page->get(2, null, null, false, null, 1);
				}
				break;
			case 'productos':
				//* Get and filter products categories
				$categories = $this->ca_page->category_get(null, null, null, 1);
				$categories = array_values(array_filter($categories, function($arr)
				{
					return preg_match('/^[3.]/', $arr['parents_path']);
				}));
				//* Get and filter products brands
				$brands = $this->ca_page->category_get(null, null, null, 1);
				$brands = array_values(array_filter($brands, function($arr)
				{
					return preg_match('/^[4.]/', $arr['parents_path']);
				}));
				$additional_data['data']['products'] = $this->ca_product->get(null, null, null, null);
				$additional_data['data']['categories'] = $categories;
				$additional_data['data']['brands'] = $brands;
				$additional_data['data']['image_sizes'] = $this->ca_utility->settings_get(null, 'products_image_sizes')[0]['items']['default']['value'];
				if (!empty($params[3]))
				{
					$additional_data['data']['item'] = $this->ca_product->get($params[3], null, null, null);
				}
				break;
			case 'usuario':
				$f_project_name = friendly_string_get($this->ca_utility->settings_get(null, 'project')[0]['items']['name']['value']);
				$additional_data['data']['item'] = $this->ca_user->get($this->encryption->decrypt($_SESSION[$f_project_name . '_data']['user_id']));
				$additional_data['data']['auth_roles'] = $this->ca_utility->settings_get(null, 'auth_roles')[0];
				break;
		}
  	return $additional_data;
	}


}
