<?php
	defined('BASEPATH') OR exit('No direct script access allowed');
	/**
	 * Content Assistant
	 *
	 * A kind of Headless CMS system build over the Codeigniter framework (http://codeigniter.com)
	 *
	 * @package   ContentAssistant
	 * @author    A59327424 @ Codeinalab
	 * @copyright 
	 * @license   
	 * @link      
	 * @version   0.10.0
	 */

	/**
   * Ca_ac_requests controller
   *
   * [Description]
   *
   * @todo
   */
	class Ca_ac_requests extends CI_Controller
	{
		public function index()
		{
			 switch($this->input->post('action'))
			 {
			 	/* AC requests */
			 	case 'submit-login';
			 		$this->_login();
			 		break;
			 	case 'submit-logout';
			 		$this->_logout();
			 		break;
			 	case 'submit-password-recover';
			 		$this->_password_recover();
			 		break;
			 	case 'submit-password-reset';
			 		$this->_password_reset();
			 		break;
			 	case 'submit-user-create';
			 		$this->_user_create();
			 		break;
			 	case 'submit-user-update';
			 		$this->_user_update();
			 		break;
			 	case 'submit-user-password-update';
			 		$this->_user_password_update();
			 		break;
			 	case 'submit-category-create';
			 		$this->_category_create();
			 		break;
			 	case 'submit-category-update';
			 		$this->_category_update();
			 		break;
			 	case 'submit-page-create';
			 		$this->_page_create();
			 		break;
			 	case 'submit-page-update';
			 		$this->_page_update();
			 		break;
			 	case 'submit-post-create';
			 		$this->_post_create();
			 		break;
			 	case 'submit-post-update';
			 		$this->_post_update();
			 		break;
			 	case 'submit-product-create';
			 		$this->_product_create();
			 		break;
			 	case 'submit-product-update';
			 		$this->_product_update();
			 		break;
			 	case 'submit-account-user-update';
			 		$this->_account_user_update();
			 		break;
			 	case 'submit-account-user-password-update';
			 		$this->_account_user_password_update();
			 		break;
			 	case 'submit-status-update';
			 		$this->_status_update();
			 		break;
			 	case 'submit-item-delete':
			 		$this->_item_delete();
			 		break;
			 	case 'submit-content-image-upload':
			 		$this->_content_image_upload();
			 		break;
			 	case 'submit-setting-create':
			 		$this->_setting_create();
			 		break;
			 	case 'submit-setting-update':
			 		$this->_setting_update();
			 		break;
			 	case 'submit-friendly-string':
			 		$this->_friendly_string();
			 		break;
			 	case 'submit-db-backup':
			 		$this->_db_backup();
			 		break;
			 	case 'submit-uploads-backup':
			 		$this->_uploads_backup();
			 		break;
			 	default:
			 		echo $this->input->post('action') . ' submit does not match any case.';
			 }
		}

		/**
		 * AC requests
		 *
		 * 
		 */
		private function _login()
		{
			$this->ca_authentication->set($this->input->post('username'), $this->input->post('password'));
			if ($this->ca_authentication->authorize())
			{
				$is_persistent = (!empty($this->input->post('is-persistent'))) ? 1 : 0;
				if ($this->ca_authentication->log($is_persistent))
				{
					$notification = $this->ca_notification->get('login', $this->ca_authentication->result_code);
				}
				else
				{
					$notification = $this->ca_notification->get('session_log', $this->ca_authentication->result_code);
				}
			}
			else
			{
				$notification = $this->ca_notification->get('login', $this->ca_authentication->result_code);
			}
			$this->session->set_flashdata('notification', $notification);
			$redirect_to = ($this->input->post('redirect')) ? $this->input->post('redirect') : '/ac';
			redirect(base_url(config_item('ca_lang') . $redirect_to), 'location', 303);
		}

		private function _logout()
		{
			($this->ca_authentication->end()) ? $page_slug = 'iniciar-sesion' : $page_slug = 'finalizar-sesion';
			$notification = $this->ca_notification->get('logout', $this->ca_authentication->result_code);
			$this->session->set_flashdata('notification', $notification);
			$redirect_to = ($this->input->post('redirect')) ? $this->input->post('redirect') : '/ac';
			redirect(base_url(config_item('ca_lang') . $redirect_to), 'location', 303);
		}

		private function _password_recover()
		{
			$email = $this->input->post('username');
			if ($this->ca_user->password_recover($email))
			{
				$data = [];
				$data['reset_code'] = urlencode($this->ca_user->result_message['reset_code']);
				$data['email'] = $email;
				$this->ca_notification->email_send('password_recover', 'Recupera tu contraseña', $data);
				$notification = $this->ca_notification->get('password_recover', $this->ca_notification->result_code);
			}
			else
			{
				$notification = $this->ca_notification->get('password_recover', $this->ca_user->result_code);
			}
			$this->session->set_flashdata('notification', $notification);
			redirect(base_url(config_item('ca_lang') . '/ac/recuperar-contrasena'), 'location', 303);
		}

		private function _password_reset()
		{
			$reset_code = $this->input->post('k');
			$password = $this->input->post('password');
			$this->ca_user->password_reset($reset_code, $password);
			$notification = $this->ca_notification->get('password_reset', $this->ca_user->result_code);
			$this->session->set_flashdata('notification', $notification);
			$redirect_to = Array('/ac/recuperar-contrasena', 
													 '/ac', 
													 '/ac/restablecer-contraseña');
			redirect(base_url(config_item('ca_lang') . $redirect_to[$this->ca_user->result_code]), 'location', 303);
		}

		private function _user_create()
		{
			$name = $this->input->post('name');
			$last_name = $this->input->post('last_name');
			$email = $this->input->post('email');
			$password = $this->input->post('password');
			$is_newsletter_subscriber = 0;
			$role_id = $this->input->post('role_id');
			$result = $this->ca_user->create($name, $last_name, $email, null, $password, 
																		null, null, null, null, null, 
																		0, $role_id);
			$notification = $this->ca_notification->get('user_create', $this->ca_user->result_code);
			$this->session->set_flashdata('notification', $notification);
			if ($result)
			{
				redirect(base_url(config_item('ca_lang') . '/ac/usuarios/') . $this->ca_user->result_message['user_id'], 'location', 303);
			}
			else
			{
				$this->session->set_flashdata('data_post', $this->input->post());
				redirect(base_url(config_item('ca_lang') . '/ac/usuarios/agregar'), 'location', 303);
			}
		}

		private function _user_update()
		{
			$user_id = $this->input->post('user_id');
			$name = $this->input->post('name');
			$last_name = $this->input->post('last_name');
			$email = $this->input->post('email');
			$role_id = $this->input->post('role_id');
			$result = $this->ca_user->update($user_id, $name, $last_name, $email, 
																			 null, null, null, null, null, 
																			 0, $role_id);
			$notification = $this->ca_notification->get('user_update', $this->ca_user->result_code);
			$this->session->set_flashdata('notification', $notification);
			redirect(base_url($this->uri->uri_string()), 'location', 303);
		}

		private function _user_password_update()
		{
			$user_id = $this->input->post('user_id');
			$new_password = $this->input->post('password');
			$result = $this->ca_user->ac_password_update($user_id, $new_password);
			$notification = $this->ca_notification->get('user_password_update', $this->ca_user->result_code);
			$this->session->set_flashdata('notification', $notification);
			redirect(base_url($this->uri->uri_string()), 'location', 303);
		}

		private function _category_create()
		{
			$parent_id =  $this->input->post('parent_id');
			$name = $this->input->post('name');
			$slug = friendly_string_get($name);
			$lang_id = $this->input->post('lang_id');
			$result = $this->ca_page->category_create($parent_id, $name, $slug, $lang_id);
			$item_id = $this->ca_page->result_message['item_id'];
			$notification = $this->ca_notification->get('category_create', $this->ca_page->result_code);
			$this->session->set_flashdata('notification', $notification);
			$redirect_to = ($result) ? '/ac/categorias/' . $item_id : '/ac/categorias/agregar';
			redirect(base_url(config_item('ca_lang') . $redirect_to), 'location', 303);
		}

		private function _category_update()
		{
			$item_id = $this->input->post('item_id');
			$parent_id = $this->input->post('parent_id');
			$name = $this->input->post('name');
			$slug = friendly_string_get($name);
			$lang_id = $this->input->post('lang_id');
			$result = $this->ca_page->category_update($item_id, $parent_id, $name, $slug, $lang_id);
			$notification = $this->ca_notification->get('category_update', $this->ca_page->result_code);
			$this->session->set_flashdata('notification', $notification);
			redirect(base_url($this->uri->uri_string()), 'location', 303);
		}

		private function _page_create()
		{
			$parent = ($this->input->post('parent')) ? explode('|', $this->input->post('parent')) : [null, ''];
			$parent_id = $parent[0];
			$parent_slug = $parent[1];
			$project_name = $this->ca_utility->settings_get(null, 'project')[0]['items']['name']['value'];
			$f_project_name = friendly_string_get($project_name);
			$author_id = $this->encryption->decrypt($_SESSION[$f_project_name . '_data']['user_id']);
			$category_id = $this->input->post('category_id');
			$meta_title = ($this->input->post('meta_title')) ? $this->input->post('meta_title') : $this->input->post('name');
			$meta_description = $this->input->post('meta_description');
			$name = $this->input->post('name');
			$content = $this->input->post('content');
			$additionals = !empty($this->input->post('additionals')) ? serialize($this->input->post('additionals')) : null;
			$slug = friendly_string_get($this->input->post('name'));
			if ('' != $parent_slug) {
				$slug = $parent_slug . '/' . $slug;
			}
			if ($this->input->post('slug'))
			{
				$slug = $this->input->post('slug');
			}
			$template = $this->input->post('template');
			$lang_id = $this->input->post('lang_id');
			$status_id = ($this->input->post('status_id')) ? $this->input->post('status_id') : 1;
			$result = $this->ca_page->create($parent_id, $author_id, $category_id, 
																	 		 $meta_title, $meta_description, 
																	 		 $name, $content, $additionals, $slug, $template, 
																	 		 $lang_id, $status_id);
			$item_id = $this->ca_page->result_message['item_id'];
			$notification = $this->ca_notification->get('page_create', $this->ca_page->result_code);
			//* Image uploads
			//* Main image 
			if (!empty($_FILES['image_file']['tmp_name']))
			{
				$image_name = friendly_string_get($item_id . '_' . $name);
				if (!$this->ca_utility->image_upload('image_file', $image_name, 'pages'))
				{
					$notification = $this->ca_notification->get('image_upload', $this->ca_utility->result_code);
				}
			}
			//* Additional images
			if (!empty($_FILES['image_file_additional']['tmp_name'][0]))
			{
				$files = $_FILES['image_file_additional'];
				for ($i = 0; $i < count($files['name']); $i++) {
					//* Create a fake input array
					$_FILES['single_image_file_additional']['name'] = $files['name'][$i];
		      $_FILES['single_image_file_additional']['type'] = $files['type'][$i];
		      $_FILES['single_image_file_additional']['tmp_name'] = $files['tmp_name'][$i];
		      $_FILES['single_image_file_additional']['error'] = $files['error'][$i];
		      $_FILES['single_image_file_additional']['size'] = $files['size'][$i];
					$file = $files['name'][$i];
					$file_info = pathinfo($file);
					$file_name =  basename($file, '.' .$file_info['extension']);
					$additional_image_name = friendly_string_get($item_id . '_' . $file_name);
					if (!$this->ca_utility->image_upload('single_image_file_additional', $additional_image_name, 'pages'))
					{
						$notification = $this->ca_notification->get('image_upload', $this->ca_utility->result_code);
					}
				}
			}
			$this->session->set_flashdata('notification', $notification);
			$redirect_to = ($result) ? '/ac/paginas/' . $item_id : '/ac/paginas/agregar';
			redirect(base_url(config_item('ca_lang') . $redirect_to), 'location', 303);
		}

		private function _page_update()
		{
			$item_id = $this->input->post('id');
			$parent = ($this->input->post('parent')) ? explode('|', $this->input->post('parent')) : [null,''];
			$parent_id = $parent[0];
			$parent_slug = $parent[1];
			$project_name = $this->ca_utility->settings_get(null, 'project')[0]['items']['name']['value'];
			$f_project_name = friendly_string_get($project_name);
			$author_id = $this->encryption->decrypt($_SESSION[$f_project_name . '_data']['user_id']);
			$category_id = $this->input->post('category_id');
			$meta_title = ($this->input->post('meta_title')) ? $this->input->post('meta_title') : $this->input->post('name');
			$meta_description = $this->input->post('meta_description');
			$name = $this->input->post('name');
			$content = $this->input->post('content');
			$additionals = !empty($this->input->post('additionals')) ? serialize($this->input->post('additionals')) : null;
			$slug = friendly_string_get($this->input->post('name'));
			if ('' != $parent_slug)
			{
				$slug = $parent_slug . '/' . $slug;
			}
			if ($this->input->post('slug'))
			{
				$slug = $this->input->post('slug');
			}
			$template = $this->input->post('template');
			$lang_id = $this->input->post('lang_id');
			$status_id = ($this->input->post('status_id')) ? $this->input->post('status_id') : 1;
			$result = $this->ca_page->update($item_id, $parent_id, $category_id, 
																			 $meta_title, $meta_description, 
																			 $name, $content, $additionals, $slug, $template, 
																			 $lang_id, $status_id);
			$notification = $this->ca_notification->get('page_update', $this->ca_page->result_code);
			//* Image uploads
			//* Main image 
			if (!empty($_FILES['image_file']['tmp_name']))
			{
				$image_name = friendly_string_get($item_id . '_' . $name);
				if (!$this->ca_utility->image_upload('image_file', $image_name, 'pages'))
				{
					$notification = $this->ca_notification->get('image_upload', $this->ca_utility->result_code);
				}
			}
			//* Additional images
			if (!empty($_FILES['image_file_additional']['tmp_name'][0]))
			{
				$files = $_FILES['image_file_additional'];
				for ($i = 0; $i < count($files['name']); $i++) {
					//* Create a fake input array
					$_FILES['single_image_file_additional']['name'] = $files['name'][$i];
		      $_FILES['single_image_file_additional']['type'] = $files['type'][$i];
		      $_FILES['single_image_file_additional']['tmp_name'] = $files['tmp_name'][$i];
		      $_FILES['single_image_file_additional']['error'] = $files['error'][$i];
		      $_FILES['single_image_file_additional']['size'] = $files['size'][$i];
					$file = $files['name'][$i];
					$file_info = pathinfo($file);
					$file_name =  basename($file, '.' .$file_info['extension']);
					$additional_image_name = friendly_string_get($item_id . '_' . $file_name);
					if (!$this->ca_utility->image_upload('single_image_file_additional', $additional_image_name, 'pages'))
					{
						$notification = $this->ca_notification->get('image_upload', $this->ca_utility->result_code);
					}
				}
			}
			$this->session->set_flashdata('notification', $notification);
			redirect(base_url($this->uri->uri_string()), 'location', 303);
		}

		private function _post_create()
		{
			$parent_id = $this->ca_page->id_by_slug_get(['blog', null], 1);
			$project_name = $this->ca_utility->settings_get(null, 'project')[0]['items']['name']['value'];
			$f_project_name = friendly_string_get($project_name);
			$author_id = $this->encryption->decrypt($_SESSION[$f_project_name . '_data']['user_id']);
			$category_id = $this->input->post('category_id');
			$meta_title = ($this->input->post('meta_title')) ? $this->input->post('meta_title') : $this->input->post('name');
			$meta_description = $this->input->post('meta_description');
			$name = $this->input->post('name');
			$content = $this->input->post('content');
			$additionals = !empty($this->input->post('additionals')) ? serialize($this->input->post('additionals')) : null;
			$slug = 'blog/post/' . friendly_string_get($this->input->post('name'));
			if ($this->input->post('slug'))
			{
				$slug = $this->input->post('slug');
			}
			$template = $this->input->post('template');
			$lang_id = $this->input->post('lang_id');
			$status_id = ($this->input->post('is_draft')) ? 0 : 1;
			$result = $this->ca_page->create($parent_id, $author_id, $category_id, 
																	 		 $meta_title, $meta_description, 
																	 		 $name, $content, $additionals, $slug, $template, 
																	 		 $lang_id, $status_id);
			$item_id = $this->ca_page->result_message['item_id'];
			$notification = $this->ca_notification->get('page_create', $this->ca_page->result_code);

			//* Image uploads
			//* Main image 
			if (!empty($_FILES['image_file']['tmp_name']))
			{
				$image_name = friendly_string_get($item_id . '_' . $name);
				if (!$this->ca_utility->image_upload('image_file', $image_name, 'posts'))
				{
					$notification = $this->ca_notification->get('image_upload', $this->ca_utility->result_code);
				}
			}

			$this->session->set_flashdata('notification', $notification);
			$redirect_to = ($result) ? '/ac/posts/' . $item_id : '/ac/posts/agregar';
			redirect(base_url(config_item('ca_lang') . $redirect_to), 'location', 303);
		}

		private function _post_update()
		{
			$item_id = $this->input->post('id');
			$parent_id = $this->ca_page->id_by_slug_get(['blog', null], 1);
			$project_name = $this->ca_utility->settings_get(null, 'project')[0]['items']['name']['value'];
			$f_project_name = friendly_string_get($project_name);
			$author_id = $this->encryption->decrypt($_SESSION[$f_project_name . '_data']['user_id']);
			$category_id = $this->input->post('category_id');
			$meta_title = ($this->input->post('meta_title')) ? $this->input->post('meta_title') : $this->input->post('name');
			$meta_description = $this->input->post('meta_description');
			$name = $this->input->post('name');
			$content = $this->input->post('content');
			$additionals = !empty($this->input->post('additionals')) ? serialize($this->input->post('additionals')) : null;			
			$slug = 'blog/post/' . friendly_string_get($this->input->post('name'));
			if ($this->input->post('slug'))
			{
				$slug = $this->input->post('slug');
			}
			$template = $this->input->post('template');
			$lang_id = $this->input->post('lang_id');
			$status_id = ($this->input->post('is_draft')) ? 0 : 1;
			$result = $this->ca_page->update($item_id, $parent_id, $category_id, 
																			 $meta_title, $meta_description, 
																			 $name, $content, $additionals, $slug, $template, 
																			 $lang_id, $status_id);
			$notification = $this->ca_notification->get('page_update', $this->ca_page->result_code);
			//* Image uploads
			//* Main image 
			if (!empty($_FILES['image_file']['tmp_name']))
			{
				$image_name = friendly_string_get($item_id . '_' . $name);
				if (!$this->ca_utility->image_upload('image_file', $image_name, 'posts'))
				{
					$notification = $this->ca_notification->get('image_upload', $this->ca_utility->result_code);
				}
			}
			$this->session->set_flashdata('notification', $notification);
			redirect(base_url($this->uri->uri_string()), 'location', 303);
		}

		private function _product_create()
		{
			$category_id = $this->input->post('category_id');
			$brand_id = $this->input->post('brand_id');
			$code = $this->input->post('code');
			$name = $this->input->post('name');
			$description = $this->input->post('description');
			$specifications = $this->input->post('specifications');
			$measures = $this->input->post('measures');
			$weight = $this->input->post('weight');
			$size = $this->input->post('size');
			$color = $this->input->post('color');
			$price = $this->input->post('price');
			$status_id = ($this->input->post('status_id')) ? $this->input->post('status_id') : 1;
			$result = $this->ca_product->create($category_id, $brand_id, $code, $name, 
																					$description, $specifications, 
																					$measures, $weight, $size, $color, $price, 
																					$status_id);
			$notification = $this->ca_notification->get('item_create', $this->ca_product->result_code);
			if ($result)
			{
				$item_id = $this->ca_product->result_message['item_id'];
				//* Upload/Resize file to img/products/[ID_friendly-image-name].ext
				//* eg. 22_some-file-name.jpg
				$image_name = friendly_string_get($item_id . '_' . $name);

				if (!$this->ca_utility->image_upload('image_file', $image_name, 'products'))
				{
					$notification = $this->ca_notification->get('image_upload', $this->ca_utility->result_code);
				}

				$this->session->set_flashdata('notification', $notification);
				redirect(base_url(config_item('ca_lang') . '/ac/productos/' . $item_id), 'location', 303);
			}
			else
			{
				$this->session->set_flashdata('data_post', $this->input->post());
				redirect(base_url(config_item('ca_lang') . '/ac/productos/agregar'), 'location', 303);
			}
		}

		private function _product_update()
		{

			$item_id = $this->input->post('product_id');
			$category_id = $this->input->post('category_id');
			$brand_id = $this->input->post('brand_id');
			$code = $this->input->post('code');
			$name = $this->input->post('name');
			$description = $this->input->post('description');
			$specifications = $this->input->post('specifications');
			$measures = $this->input->post('measures');
			$weight = $this->input->post('weight');
			$size = $this->input->post('size');
			$color = $this->input->post('color');
			$price = $this->input->post('price');
			$image_file = $this->input->post('image_file');
			$result = $this->ca_product->update($item_id, $category_id, $brand_id, $code, $name, $description, $specifications, $measures, $weight, $size, $color, $price);
			$notification = $this->ca_notification->get('item_update', $this->ca_product->result_code);
			if ($result)
			{
				if (!empty($_FILES['image_file']['tmp_name']))
				{
					//* Upload/Resize file to img/products/[ID_friendly-image-name].ext
					//* eg. 22_some-file-name.jpg
					$image_name = friendly_string_get($item_id . '_' . $name);
					if (!$this->ca_utility->image_upload('image_file', $image_name, 'products', config_item('ca_product_image_size')))
					{
						$notification = $this->ca_notification->get('image_upload', $this->ca_utility->result_code);
					}
					//* Create thumbnail img/products/[ID_image-friendly-name_suffix].ext
					//* eg. 22_some-file-name_th.jpg
					$ext = $this->ca_utility->result_message['file_ext'];
					if (!$this->ca_utility->image_resize($image_name, $ext, 'products', config_item('ca_product_thumb_size'), '_th'))
					{
						$notification = $this->ca_notification->get('image_resize', $this->ca_utility->result_code);
					}
				}
			}

			$this->session->set_flashdata('notification', $notification);
			redirect(base_url($this->uri->uri_string()), 'location', 303);

		}

		private function _account_user_update()
		{
			$project_name = $this->ca_utility->settings_get(null, 'project')[0]['items']['name']['value'];
			$f_project_name = friendly_string_get($project_name);
			$current_user = $this->ca_user->get($this->encryption->decrypt($_SESSION[$f_project_name . '_data']['user_id']));
			$user_id = $current_user[0]['id'];
			$name = $this->input->post('name');
			$last_name = $this->input->post('last_name');
			$email = $this->input->post('email');
			$role_id = $current_user[0]['role_id'];
			$result = $this->ca_user->update($user_id, $name, $last_name, $email, 
																			 null, null, null, null, null, 
																			 0, $role_id);
			$notification = $this->ca_notification->get('account_user_update', $this->ca_user->result_code);
			$this->session->set_flashdata('notification', $notification);
			redirect(base_url($this->uri->uri_string()), 'location', 303);
		}

		private function _account_user_password_update()
		{
			$project_name = $this->ca_utility->settings_get(null, 'project')[0]['items']['name']['value'];
			$f_project_name = friendly_string_get($project_name);
			$current_user = $this->ca_user->get($this->encryption->decrypt($_SESSION[$f_project_name . '_data']['user_id']));
			$user_id = $current_user[0]['id'];
			$user_email = $current_user[0]['email'];
			$current_password = $this->input->post('current_password');
			$new_password = $this->input->post('password');
			$result = $this->ca_user->password_update($user_id, $user_email, $current_password, $new_password);
			$notification = $this->ca_notification->get('account_user_password_update', $this->ca_user->result_code);
			$this->session->set_flashdata('notification', $notification);
			redirect(base_url($this->uri->uri_string()), 'location', 303);
		}

		private function _status_update()
		{
			$item_type = $this->input->post('item_type'); //* Table name
			$item_id = $this->input->post('item_id');
			$status_id = $this->input->post('status_id');
			$result = $this->ca_utility->status_update($item_type, $item_id, $status_id);
			$notification = $this->ca_notification->get('item_update', $this->ca_utility->result_code);
			$this->session->set_flashdata('notification', $notification);
			redirect(base_url($this->uri->uri_string()), 'location', 303);
		}

		private function _item_delete()
		{
			$item_type = $this->input->post('item_type'); //* Table name
			$item_id = $this->input->post('item_id');
			$redirect_to = $this->input->post('redirect');
			if ('posts' == $item_type) {
				$item_type = 'pages';
			}

			$result = $this->ca_utility->item_delete($item_type, $item_id);
			$notification = $this->ca_notification->get('item_delete', $this->ca_utility->result_code);
			$this->session->set_flashdata('notification', $notification);
			redirect(base_url(config_item('ca_lang') . '/ac/' . $redirect_to), 'location', 303);
		}

		private function _content_image_upload()
		{
			$pathinfo = pathinfo($_FILES['file']['name']);
			$image_name = friendly_string_get($pathinfo['filename']);
			$image_type = $_POST['content'];
			$image_size = config_item('ca_page_image_size');
			if ($this->ca_utility->image_upload('file', $image_name, $image_type . 's', null))
			{
				//return uploaded file path
				$ext = $this->ca_utility->result_message['file_ext'];
				echo json_encode(array('location' => 'img/uploads/' . $image_type . 's/' . $image_name . $ext));
			}
			else
			{
				header("HTTP/1.1 500 Server Error");
			}
		}

		private function _friendly_string()
		{
			header('Content-type: application/json; charset=utf-8');
			$string = $this->input->post('string');
			$response = [];
			$response['string'] = $string;
			$response['friendly_string'] = friendly_string_get($string);
			echo json_encode($response);
		}

		private function _setting_create()
		{
			$name = $this->input->post('name');
			$keys = array_reverse($this->input->post('keys'));
			$values = array_reverse($this->input->post('values'));
			$settings = [];
			for ($i = 0; $i < count($keys); $i++) {
				if (!empty($keys[$i]))
				{
					$key = $keys[$i];
					$settings[$key]['id'] = $i + 1;
					$settings[$key]['value'] = $values[$i];
				}
			}
			$result = $this->ca_utility->settings_add($name, serialize($settings));
			$notification = $this->ca_notification->get('item_create', $this->ca_utility->result_code);
			$this->session->set_flashdata('notification', $notification);
			redirect(base_url(config_item('ca_lang') . '/ac/configuracion'), 'location', 303);
		}

		private function _setting_update()
		{
			$item_id = $this->input->post('item_id');
			$name = $this->input->post('name');
			$keys = array_reverse($this->input->post('keys'));
			$values = array_reverse($this->input->post('values'));
			$settings = [];
			for ($i = 0; $i < count($keys); $i++) {
				if (!empty($keys[$i]))
				{
					$key = $keys[$i];
					$settings[$key]['id'] = $i + 1;
					$settings[$key]['value'] = $values[$i];
				}
			}
			$result = $this->ca_utility->settings_update($item_id, $name, serialize($settings));
			$notification = $this->ca_notification->get('item_update', $this->ca_utility->result_code);
			$this->session->set_flashdata('notification', $notification);
			redirect(base_url($this->uri->uri_string()), 'location', 303);
		}

		private function _db_backup()
		{
			$project_name = $this->ca_utility->settings_get(null, 'project')[0]['items']['name']['value'];
			$filename = $project_name . ' ' . ENVIRONMENT . '_' . date('Y-m-d') . '.sql';
			$this->load->dbutil();
			$preferences = [
        //'ignore' => [config_item('ca_tables_prefix').'sessions'],
        'format' => 'txt',
        'filename' => $filename,
        'add_drop' => TRUE,
        'add_insert' => TRUE
			];
			$backup = $this->dbutil->backup($preferences);
			$this->load->helper('download');
			force_download($filename, $backup);
		}

		private function _uploads_backup()
		{
			$project_name = $this->ca_utility->settings_get(null, 'project')[0]['items']['name']['value'];
			$filename = $project_name . ' ' . ENVIRONMENT . ' uploads_' . date('Y-m-d') . '.zip';
			$this->load->library('zip');
			$path = FCPATH . '/img/uploads/';
			$this->zip->read_dir($path, FALSE);
			$this->zip->download($filename);

		}

	}