<?php
  defined('BASEPATH') OR exit('No direct script access allowed');
  /**
   * Content Assistant
   *
   * A kind of Headless CMS system build over the Codeigniter framework (http://codeigniter.com)
   *
   * @package   ContentAssistant
   * @author    A59327424 @ Codeinalab
   * @copyright 
   * @license   
   * @link      
   * @version   0.10.0
   */

  /**
   * Ca_pages controller
   *
   * [Description]
   *
   * @todo
   */
  class Ca_migrations extends CI_Controller
  {

  	public function index()
    {
      $data = [];
      $data['data']['ca_migration_enabled'] = config_item('ca_migration_enabled');
      $data['data']['hex_key'] = (empty(config_item('encryption_key'))) ? false : true;
      $data['data']['setup_hex_key'] = ''; 
      if (empty(config_item('encryption_key')))
      {
        $data['data']['setup_hex_key'] = bin2hex($this->encryption->create_key(16));  
      }
      $this->load->view('ac/ca_ac_setup.php', $data);
    }

    public function do()
    {
      if ('submit-setup' == $this->input->post('action'))
      {
        $this->load->library('migration');
        if ($this->migration->current() === FALSE)
        {
          show_error($this->migration->error_string());
        }
        else
        {
          $notification = $this->ca_notification->get('migration', 1);
          $this->session->set_flashdata('notification', $notification);
          $available_languages = $this->ca_utility->settings_get(null, 'languages')[0];
          if (1 < count($available_languages['items']))
          {
            $default_language = $available_languages['items'][array_keys($available_languages['items'])[0]]['value'];
            $this->config->set_item('ca_lang', $default_language);
          }
          redirect(base_url($default_language . '/ac'), 'location', 303);
        }
      }
    }

  }