<?php
	defined('BASEPATH') OR exit('No direct script access allowed');
	/**
	 * Content Assistant
	 *
	 * A kind of Headless CMS system build over the Codeigniter framework (http://codeigniter.com)
	 *
	 * @package   ContentAssistant
	 * @author    A59327424 @ Codeinalab
	 * @copyright 
	 * @license   
	 * @link      
	 * @version   0.10.0
	 */

  /**
   * Ca_pages controller
   *
   * [Description]
   *
   * @todo
   */
	class Ca_pages extends CI_Controller
	{


		/**
		 * index
		 *
		 * Default function, this will 
		 * catch all url GET requests
		 * check for authentication
		 * get 
		 * default page info 
		 * additional data 
		 * or notification
		 * and then will load view
		 *
		 * @param  string $param_1 section or language
		 * @param  string $param_2 section, subsection or param
		 * @param  mixed $param_3 optional
		 * @param  mixed $param_4 optional
		 * @param  mixed $param_5 optional
		 *
		 * @return [type] [description]
		 */
		public function index($param_1 = null, 
													$param_2 = null,
													$param_3 = null,
													$param_4 = null,
													$param_5 = null,
													$param_6 = null)
		{
			// Create an array with url params (segments)
			$params = array_pad(func_get_args(), 6, null);
			// First url param can be an available language code eg. es-mx
			// Remove from array if it is
			// language is previously defined by the language model
			// and accessed using config_item('ca_lang')
			$avaliable_languages = $this->ca_utility->settings_get(null, 'languages')[0];
			if (in_array($params[0], array_column($avaliable_languages['items'], 'value')))
			{
				array_shift($params);
			}
			if (is_null($params[0]))
			{
				$params[0] = friendly_string_get($this->lang->line('ca_home'));
			}
			$data = [];
			/* Auth */
			$data['data']['auth']['session'] = $this->ca_authentication->check();
			if (!empty($data['data']['auth']['session'])) {
				$f_project_name = friendly_string_get($this->ca_utility->settings_get(null, 'project')[0]['items']['name']['value']);
			  $data['data']['user'] = $this->ca_user->get($this->encryption->decrypt($_SESSION[$f_project_name . '_data']['user_id']))[0];
			}
			// Page data
			$data['data']['params'] = $params;
			$id = $this->ca_page->id_by_slug_get($params, 1);

			if ('catalogo' == $params[0] && 'producto' == $params[1] && !empty($params[2]))
			{
				$data['data']['page'] = $this->ca_product->get($id, null, false, false, null, 1)[0];
			}
			else
			{
				$data['data']['page'] = $this->ca_page->get($id, null, false, false, null, 1)[0];
			}

			$data['data']['page']['is_ac'] = false;
			/* Additional data */
			$additional_data = $this->_additional_data_get($params);
			$data = array_replace_recursive($data, $additional_data);
			/* Notification */
			$data['data']['notification'] = array('type' => '', 'message' => '');
			if ($this->session->flashdata('notification')) {
				$data['data']['notification'] = $this->session->flashdata('notification');
			}
			/* Load view */
			$this->_load_view($data);
		}


		/**
		 * Load views
		 *
		 * @param  array $data
		 */
		private function _load_view($data) {
			$header = 'ca_partials_header';
			$footer = 'ca_partials_footer';
			$theme_path = config_item('ca_project_theme') . '/';
			if ('404' == $data['data']['page']['slug']) {
				$this->output->set_status_header('404');
			}
			$this->load->view($header . '.php', $data);
			$this->load->view($data['data']['page']['template']);
			$this->load->view($footer . '.php');
		}


		private function _additional_data_get($params)
		{
			$additional_data = [];
			//* Add any additional data that will be used through all the site 
			$additional_data['data']['project'] = $this->ca_utility->settings_get(null, 'project')[0];
			//* Add a case for specific sections of the site
			switch($params[0]) {
				case 'inicio':
					//$additional_data['data']['featured_products'] = $this->ca_product->get(null, null, null, 1, 2);
					$additional_data['data']['products'] = $this->ca_product->get(null, null, null, 1, null);
					break;
				case 'catalogo':
					$categories = $this->ca_page->category_get(null, 3, 1, 1);
					array_multisort(array_column($categories, 'created'), SORT_ASC, $categories);
					$additional_data['data']['categories'] = $categories;
          $products = $this->ca_product->get(null, null, null, 1, null);
					$additional_data['data']['products'] = $products;
          // related products
					break;
				case 'blog';
					//* Get and filter blog categories
					$blog_category_id = $this->ca_page->category_id_by_slug_get('blog', 1);
					$categories = $this->ca_page->category_get(null, null, config_item('ca_lang_id'), 1);
					$categories = array_values(array_filter($categories, function($arr) use($blog_category_id)
					{
						return preg_match('/^(' . $blog_category_id . ')+\.?/', $arr['parents_path']);
					}));
					$additional_data['data']['categories'] = $categories;
					//* Get latest posts
					$category_id = $this->ca_page->category_id_by_slug_get($params[2], 1); //* url blog/categories/[category_slug]
					$blog_page_id = $this->ca_page->id_by_slug_get(['blog', null, null, null,], 1);

					$additional_data['data']['latest_posts'] = $this->ca_page->get(null, $category_id, $blog_page_id, false, config_item('ca_lang_id'), 1);
					break;
				default:
			}
			return $additional_data;
		}


	}
