<?php
	defined('BASEPATH') OR exit('No direct script access allowed');
	/**
	 * Content Assistant
	 *
	 * A kind of Headless CMS system build over the Codeigniter framework (http://codeigniter.com)
	 *
	 * @package   ContentAssistant
	 * @author    A59327424 @ Codeinalab
	 * @copyright 
	 * @license   
	 * @link      
	 * @version   0.10.0
	 */

  /**
   * Ca_requests controller
   *
   * [Description]
   *
   * @todo
   */
	class Ca_requests extends CI_Controller
	{
		public function index()
		{
			 switch($this->input->post('action'))
			 {
			 	/* Public requests */
			 	case 'submit-contact';
			 		$this->_contact_send();
			 		break;
			 	default:
			 		echo $this->input->post('action') . ' submit does not match any case.';
			 }
		}

		private function _contact_send_validation()
		{
			$result = false;
			if (!empty($this->input->post('name')) && 
				  filter_var($this->input->post('email'), FILTER_VALIDATE_EMAIL) && 
				  !empty($this->input->post('comments')) && 
					empty($this->input->post('input-verification')))
			{
				$result = true;
				// Validate recaptcha only if keys are set
				if (!empty(config_item('ca_g_recaptcha')))
				{
					$result = $this->ca_notification
												 ->g_recaptcha_validation($this->input->post('g-recaptcha-response'), 
																									$_SERVER['SERVER_NAME'],
																									'contact',
																									$this->input->ip_address());
				}
			}
			return $result;
		}
		private function _contact_send()
		{
			if ($this->_contact_send_validation())
			{
				$name_from = $this->input->post('name');
				$email_from = $this->input->post('email');
				$comments = $this->input->post('comments');
				$subject = 'Contacto web';
				$m = 'Nombre: ' . $name_from;
				$m.= '<br />E-mail: ' . $email_from;
				$m.= '<br /><br />' . $comments;
				$message = $m;
				$result = $this->ca_notification->email_send($name_from, $email_from, $subject, $message);
				$result_code = $this->ca_notification->result_code;
				$notification = $this->ca_notification->get('email_send', $result_code);
			}
			else
			{
				$result = false;
				$result_code = $this->ca_notification->result_code;
				$notification = $this->ca_notification->get('validation', $result_code);
			}

			if ($this->input->post('is-ajax'))
			{
				/* Return a JSON response */
				header('Content-type: application/json');
				$response = [];
		    $response['status'] = $result; //* Boolean
		    $response['result_code'] = $result_code;
		    $response['result_message'] = $this->ca_notification->result_message;
		    $response['notification'] = $notification;
		    echo json_encode($response);
		    exit();
			}
			else
			{
				/* PRG */
				$this->session->set_flashdata('notification', $notification);
				redirect(base_url(uri_string()), 'location', 303);
			}
		}

	}