<?php
  /**
   * Content Assistant
   *
   * A kind of Headless CMS system build over the Codeigniter framework (http://codeigniter.com)
   *
   * @package   ContentAssistant
   * @author    A59327424 @ Codeinalab
   * @copyright 
   * @license   
   * @link      
   * @version   0.10.0
   */

	/**
	 * Friendly string
	 * 
	 * Returns a safe string for URLs, filenames, etc.
	 * Replace/Remove special characters and spaces
	 *
	 * @param  string $string Human string
	 *
	 * @return string
   *
   *@todo  Use config/foreign_chars file
	 */
	function friendly_string_get($string)
	{
		$friendly_string = trim($string);
		//* Special characters remove
		$remove = array('!', '¡', '@', '#', '$', '%', '(', ')', '?', '¿', '=', 
										'[', ']', '{', '}', '+', ',', '.', ';', ':', '<', '>', '¦', '*','"','“','”');
		$friendly_string = str_replace($remove, '', $friendly_string);
		//* Specific replacement
		$replace = array('á','é','í','ó','ú','Á','É','Í','Ó','Ú',
						 'ä','ë','ï','ö','ü','Ä','Ë','Ï','Ö','Ü',
						 'â','ê','î','ô','û','Â','Ê','Î','Ô','Û',
						 'à','è','ì','ò','ù','À','È','Ì','Ò','Ù',
						 'ñ','Ñ','ç','Ç','º','ª','°','&',' - ',' ', '/');
		$replace_to = array('a','e','i','o','u','A','E','I','O','U',
							'a','e','i','o','u','A','E','I','O','U',
							'a','e','i','o','u','A','E','I','O','U',
							'a','e','i','o','u','A','E','I','O','U',
							'n','N','c','C','o','a','o','and','-','-','-');
		for ($i = 0; $i <= count($replace) - 1; $i++) {
			$friendly_string = str_replace($replace[$i], $replace_to[$i], $friendly_string);
		}
		return strtolower($friendly_string);
	}
	/**
   * Excerpt
   *
   * Creates an exceprt from a given text string 
   * Removes html tags
   * Characters in final string will be <= than the specified limit
   * Including 3 dots of ellipsis
   * Cuts the string by complete words (spaces), so character count in final 
   * result will not be === to limit, but a reasonable approximation
   *
   * @param  string  $string The string to be shortened
   * @param  integer $limit The number of characters the excerpt will be limited to
   *
   * @return string Shortened string with ellipsis at the end
   */
  function excerpt_get($string, $limit)
  {
    $string = strip_tags($string);
    return substr($string, 0, strrpos($string, ' ', ($limit - 3 - strlen($string)))) . '...';
  }