<?php
	defined('BASEPATH') OR exit('No direct script access allowed');
  /**
   * Content Assistant
   *
   * A kind of Headless CMS system build over the Codeigniter framework (http://codeigniter.com)
   *
   * @package   ContentAssistant
   * @author    A59327424 @ Codeinalab
   * @copyright 
   * @license   
   * @link      
   * @version   0.10.0
   */

  /**
   * Ca_migrtion model
   *
   * This model builds the Ca DB
   *
   * @todo
   */
	class Migration_Ca_setup extends CI_Migration {

		/**
		 * Up
		 * Setup bootstrap
		 *
		 * @return boolean
		 */
		public function up()
		{
			$this->_settings();
			$this->_sessions();
			$this->_categories();
			$this->_users();
			$this->_pages();
			$this->_products();
		}

		/**
		 * Down
		 * Setup reset
		 *
		 * @return boolean
		 */
		public function down()
		{
			//$this->dbforge->drop_table('table');
		}

		/**
		 * Settings
		 *
		 * @return  bolean
		 */
		private function _settings()
		{
			/* Define table name */
			$table = config_item('ca_tables_prefix') . 'settings';
			/* Define table fields */
			/**
			 * id
			 * setting
			 * value
			 * created
			 * modified
			 * status_id
			 */
			$this->dbforge->add_field(
				array('id' => array('type' => 'INT', 'constraint' => 11, 'auto_increment' => TRUE),
							'name' => array('type' => 'VARCHAR', 'constraint' => 50, 'null' => FALSE),
							'items' => array('type' => 'TEXT', 'null' => TRUE),
							'created' => array('type' => 'DATETIME'),
					  	'modified' => array('type' => 'DATETIME'),
					  	'status_id' => array('type' => 'INT', 'constraint' => 1, 'default' => 1),
				)
			);
			/* Set primary key */
	    $this->dbforge->add_key('id', TRUE);
	    /* Create table */
	    $result = $this->dbforge->create_table($table, TRUE);
	    if ($result) {
		    $now = date('Y-m-d H:i:s');
		    /* insert default data */
		    $data = array(
		    							array(
		    								'name' => 'project',
		    								'items' => serialize(
		    									array(
		    										'name' => array(
		    											'id' => 1,
		    											'value' => 'CA Project'
		    										),
		    										'email' => array(
		    											'id' => 2,
		    											'value' => 'email@email.com'
		    										),
		    										'email_cc' => array(
		    											'id' => 3,
		    											'value' => ''
		    										),
		    										'email_bcc' => array(
		    											'id' => 4,
		    											'value' => ''
		    										),
		    										'g_analytics_tracking_id' => array(
															'id' => 5,
															'value' => ''
														),
														'g_recaptcha_site_key' => array(
															'id' => 6,
															'value' => ''
														),
														'g_recaptcha_secret_key' => array(
															'id' => 7,
															'value' => ''
														),
		    									)
		    								),
		    								'created' => $now,
		    								'modified' => $now
		    							),

		    							array(
		    								'name' => 'languages',
		    								'items' => serialize(
		    									array(
			    									'spanish' => array(
			    										'id' => 1,
			    										'value' => 'es-mx'
			    									),
		    									)
		    								),
		    								'created' => $now,
		    								'modified' => $now
		    							),

		    							array(
		    								'name' => 'templates',
		    								'items' => serialize(
		    									array(
			    									'Default' => array(
			    										'id' => 1,
			    										'value' => 'default'
			    									),
			    									'Home' => array(
			    										'id' => 2,
			    										'value' => 'home'
			    									),
			    									'Blog' => array(
			    										'id' => 3,
			    										'value' => 'blog'
			    									),
			    									'Post' => array(
			    										'id' => 4,
			    										'value' => 'post'
			    									),
			    									'Catalogue' => array(
			    										'id' => 5,
			    										'value' => 'catalogue'
			    									),
			    									'Product' => array(
			    										'id' => 6,
			    										'value' => 'product'
			    									),
		    									)
		    								),
		    								'created' => $now,
		    								'modified' => $now
		    							),

		    							array(
		    								'name' => 'pages_image_sizes',
		    								'items' => serialize(
		    									array(
		    										'default' => array(
			    										'id' => 1,
			    										'value' => '2048,600'
			    									),
			    									'thumb' => array(
			    										'id' => 2,
			    										'value' => '255,255'
			    									),
			    									'width_breakpoints' => array(
			    										'id' => 3,
			    										'value' => '1140,1024,780'
			    									),
		    									)
		    								),
		    								'created' => $now,
		    								'modified' => $now
		    							),
		    							array(
		    								'name' => 'pages_additional_fields',
		    								'items' => serialize(
		    									array(
			    									'additional_field_name' => array(
			    										'id' => 1,
			    										'value' => ''
			    									),
		    									)
		    								),
		    								'created' => $now,
		    								'modified' => $now
		    							),

		    							array(
		    								'name' => 'posts_image_sizes',
		    								'items' => serialize(
		    									array(
		    										'default' => array(
			    										'id' => 1,
			    										'value' => '2048,600'
			    									),
			    									'thumb' => array(
			    										'id' => 2,
			    										'value' => '255,255'
			    									),
			    									'width_breakpoints' => array(
			    										'id' => 3,
			    										'value' => '1140, 1024, 780'
			    									),
		    									)
		    								),
		    								'created' => $now,
		    								'modified' => $now
		    							),
		    							array(
		    								'name' => 'posts_additional_fields',
		    								'items' => serialize(
		    									array(
			    									'additional_field_name' => array(
			    										'id' => 1,
			    										'value' => ''
			    									),
		    									)
		    								),
		    								'created' => $now,
		    								'modified' => $now
		    							),

		    							array(
		    								'name' => 'products_image_sizes',
		    								'items' => serialize(
		    									array(
		    										'default' => array(
			    										'id' => 1,
			    										'value' => '1024,1024'
			    									),
			    									'thumb' => array(
			    										'id' => 2,
			    										'value' => '255,255'
			    									),
			    									'width_breakpoints' => array(
			    										'id' => 3,
			    										'value' => '980,640'
			    									),
		    									)
		    								),
		    								'created' => $now,
		    								'modified' => $now
		    							),
		    							array(
		    								'name' => 'products_additional_fields',
		    								'items' => serialize(
		    									array(
			    									'additional_field_name' => array(
			    										'id' => 1,
			    										'value' => ''
			    									),
		    									)
		    								),
		    								'created' => $now,
		    								'modified' => $now
		    							),
		    							
		    							
		    							array(
		    								'name' => 'auth_roles', 
		    								'items' => serialize(
		    									array(
		    										'user' => array(
		    											'id' => 1, 
		    											'value' => 'Usuario'
		    										),
		    										'admin' => array(
		    											'id' => 2, 
		    											'value' => 'Editor'
		    										),
		    										'sysadmin' => array(
		    											'id' => 3, 
		    											'value' => 'Administrador'
		    										),
		    									)
		    								),  
		    								'created' => $now, 
		    								'modified' => $now
		    							),
		    						);

		    $this->db->insert_batch($table, $data);
	    }
	    return $result;
		}

		/**
		 * Sessions
		 *
		 * @return boolean
		 */
		private function _sessions()
		{
			/* Define table name */
			$table = config_item('ca_tables_prefix') . 'sessions';
			/* Define table fields */
			/**
			 * id
			 * user_id
			 * session
			 * ip
			 * start
			 * end
			 * is_persistent
			 * status_id
			 */
			$this->dbforge->add_field(
				array('id' => array('type' => 'INT', 'constraint' => 11, 'auto_increment' => TRUE),
					  	'user_id' => array('type' => 'INT', 'constraint' => 11,),
					  	'session' => array('type' => 'VARCHAR', 'constraint' => 100,),
					  	'ip' => array('type' => 'VARCHAR', 'constraint' => 64),
					  	'start' => array('type' => 'DATETIME'),
					  	'end' => array('type' => 'DATETIME'),
					  	'is_persistent' => array('type' => 'INT', 'constraint' => 1, 'default' => 0),
					  	'status_id' => array('type' => 'INT', 'constraint' => 1, 'default' => 1,)
				)
			);
			/* Define primary key */
	    $this->dbforge->add_key('id', TRUE);
			/* Create table */
			$result = $this->dbforge->create_table($table, TRUE);
			return $result;
		}

		/**
		 * Categories
		 *
		 * @return boolean
		 */
		private function _categories()
		{
			/* Define table name */
			$table = config_item('ca_tables_prefix') . 'categories';
			/* Define table fields */
			/**
			 * id
			 * parent_id
			 * name
			 * slug
			 * created
			 * modified
			 * status_id
			 */
			/* Define table fields */
			$this->dbforge->add_field(
				array('id' => array('type' => 'INT', 'constraint' => 11, 'auto_increment' => TRUE),
					    'parent_id' => array('type' => 'INT', 'constraint' => 11, 'null' => TRUE),
					    'name' => array('type' => 'VARCHAR', 'constraint' => 255, 'null' => TRUE),
					    'slug' => array('type' => 'VARCHAR', 'constraint' => 255, 'null' => TRUE),
					    'lang_id' => array('type' => 'INT', 'constraint' => 1, 'default' => 1, 'null' => TRUE),
					    'created' => array('type' => 'DATETIME'),
					    'modified' => array('type' => 'DATETIME'),
					    'status_id' => array('type' => 'INT', 'constraint' => 1, 'default' => 1)
				)
			);
			/* Define primary key */
	    $this->dbforge->add_key('id', TRUE);
	    /* Create table */
	    $result = $this->dbforge->create_table($table, TRUE);
	    if ($result) {
		    $now = date('Y-m-d H:i:s');
		    /* insert default data */
		    $data = array(
		    	array(
		    		'parent_id' => null, 
		    		'name' => 'Páginas', 
		    		'slug' => 'pages', 
						'lang_id' => null,
		    		'created' => $now, 
		    		'modified' => $now),
		    	array(
		    		'parent_id' => null, 
		    		'name' => 'Blog', 
		    		'slug' => 'blog', 
						'lang_id' => null,
		    		'created' => $now, 
		    		'modified' => $now),
		    	array(
		    		'parent_id' => null, 
		    		'name' => 'Productos', 
		    		'slug' => 'products', 
						'lang_id' => null,
		    		'created' => $now, 
		    		'modified' => $now),
		    	array(
		    		'parent_id' => null, 
		    		'name' => 'Marcas', 
		    		'slug' => 'brands', 
						'lang_id' => null,
		    		'created' => $now, 
		    		'modified' => $now),
		    );
		    $this->db->insert_batch($table, $data);
		    }
	    return $result;
		}

		/**
		 * Users
		 *
		 * @return boolean
		 */
		private function _users()
		{
			/* Define table name */
			$table = config_item('ca_tables_prefix') . 'users';
			/* Define table fields */
			/**
			 * id
			 * name
			 * last_name
			 * email
			 * username
			 * password
			 * reset_code
			 * verification_code
			 * gender
			 * dob
			 * telephone
			 * mobile_phone
			 * is_newsletter_subscriber
			 * role_id
			 * privileges
			 * created
			 * modified
			 * status_id
			 */
			$this->dbforge->add_field(
				array('id' => array('type' => 'INT', 'constraint' => 11, 'auto_increment' => TRUE),
					  	'name' => array('type' => 'VARCHAR', 'constraint' => 255, 'null' => TRUE,),
					  	'last_name' => array('type' => 'VARCHAR', 'constraint' => 255, 'null' => TRUE,),
					  	'email' => array('type' => 'VARCHAR', 'constraint' => 255,),
					  	'username' => array('type' => 'VARCHAR', 'constraint' => 255, 'null' => TRUE,),
					  	'password' => array('type' => 'TEXT',),
					  	'reset_code' => array('type' => 'VARCHAR', 'constraint' => 255, 'null' => TRUE,),
					  	'verification_code' => array('type' => 'VARCHAR', 'constraint' => 255, 'null' => TRUE,),
					  	'gender' => array('type' => 'VARCHAR', 'constraint' => 1, 'null' => TRUE,),
					  	'dob' => array('type' => 'DATE', 'null' => TRUE,),
					  	'telephone' => array('type' => 'VARCHAR', 'constraint' => 24, 'null' => TRUE,),
					  	'mobile_phone' => array('type' => 'VARCHAR', 'constraint' => 24, 'null' => TRUE,),
					  	'is_newsletter_subscriber' => array('type' => 'INT', 'constraint' => 1, 'default' => 1),
					  	'role_id' => array('type' => 'INT', 'constraint' => 1, 'default' => 1),
					  	'created' => array('type' => 'DATETIME'),
					  	'modified' => array('type' => 'DATETIME'),
					  	'status_id' => array('type' => 'INT', 'constraint' => 1, 'default' => 1)
				)
			);
			/* Set primary key */
	    $this->dbforge->add_key('id', TRUE);
	    /* Create table */
	    $result = $this->dbforge->create_table($table, TRUE);
	    if ($result) {
		    $hashed_password = password_hash('password', PASSWORD_DEFAULT);
		    $now = date('Y-m-d H:i:s');
		    /* insert default data */
		    $data = array('name' => 'admin', 
		    							'email' => 'admin@admin.com', 
		    							'password' => $hashed_password, 
		    							'role_id' => 3, 
		    							'created' => $now, 
		    							'modified' => $now);
		    $this->db->insert($table, $data);
	    }
	    return $result;
		}

		/**
		 * Pages
		 *
		 * @return boolean
		 */
		private function _pages()
		{
			/* Define table name */
			$table = config_item('ca_tables_prefix') . 'pages';
			/* Define table fields */
			/**
			 * id
			 * parent_id
			 * author_id
			 * category_id
			 * meta_title 				//* meta title
			 * meta_description 	//* meta description
			 * name 							//* Section name
			 * content 						//* html content
			 * slug 							//* URL
			 * template 					//* View file
			 * created
			 * modified
			 * status_id
			 */
			$this->dbforge->add_field(
				array('id' => array('type' => 'INT', 'constraint' => 11, 'auto_increment' => TRUE),
					    'parent_id' => array('type' => 'INT', 'constraint' => 11, 'null' => TRUE,),
					    'author_id' => array('type' => 'INT', 'constraint' => 11, 'null' => FALSE, 'default' => 1),
					    'category_id' => array('type' => 'INT', 'constraint' => 11, 'null' => TRUE,),
					    'meta_title' => array('type' => 'VARCHAR', 'constraint' => 160, 'null' => TRUE),
					    'meta_description' => array('type' => 'VARCHAR', 'constraint' => 300, 'null' => TRUE),
					    'name' => array('type' => 'VARCHAR', 'constraint' => 255,),
					    'content' => array('type' => 'TEXT', 'null' => TRUE,),
					    'additionals' => array('type' => 'TEXT', 'null' => TRUE,),
					    'slug' => array('type' => 'VARCHAR', 'constraint' => 255,),
					    'template' => array('type' => 'VARCHAR', 'constraint' => 255, 'default' => 'ca_template_default',),
					    'lang_id' => array('type' => 'INT', 'constraint' => 1, 'default' => 1, 'null' => TRUE),
					    'created' => array('type' => 'DATETIME',),
					    'modified' => array('type' => 'DATETIME',),
					    'status_id' => array('type' => 'INT', 'constraint' => 1, 'default' => 1,),
				)
			);
			/* Set primary key */
	    $this->dbforge->add_key('id', TRUE);
	    /* Create table */
	    $result = $this->dbforge->create_table($table, TRUE);
	    if ($result) {
		    $now = date('Y-m-d H:i:s');
		    /* insert default data */
		    $data = array(
					/* Default ca ac pages */
		    	array('parent_id' => null, 
		  					'category_id' => null,  
		    				'name' => 'AC', 
		    				'meta_title' => 'Consola de administración', 
		    				'slug' => 'ac/inicio', 
		    				'lang_id' => null,
		    				'template' => 'ca_ac_home', 
		    				'created' => $now, 
		    				'modified' => $now),
		    	array('parent_id' => 1, 
		  					'category_id' => null,
		    				'name' => 'AC - Configuración', 
		    				'meta_title' => 'AC - Configuración', 
		    				'slug' => 'ac/configuracion', 
		    				'lang_id' => null,
		    				'template' => 'ca_ac_default', 
		    				'created' => $now, 
		    				'modified' => $now),
		    	array('parent_id' => 1, 
		  					'category_id' => null,
		    				'name' => 'AC - Usuarios', 
		    				'meta_title' => 'AC - Usuarios', 
		    				'slug' => 'ac/usuarios', 
		    				'lang_id' => null,
		    				'template' => 'ca_ac_default', 
		    				'created' => $now, 
		    				'modified' => $now),
		    	array('parent_id' => 1, 
		  					'category_id' => null,
		    				'name' => 'AC - Páginas', 
		    				'meta_title' => 'AC - Páginas', 
		    				'slug' => 'ac/paginas', 
		    				'lang_id' => null,
		    				'template' => 'ca_ac_default', 
		    				'created' => $now, 
		    				'modified' => $now),
		    	array('parent_id' => 1, 
		  					'category_id' => null,
		    				'name' => 'AC - Productos', 
		    				'meta_title' => 'AC - Productos', 
		    				'slug' => 'ac/productos', 
		    				'lang_id' => null,
		    				'template' => 'ca_ac_default', 
		    				'created' => $now, 
		    				'modified' => $now),
		    	array('parent_id' => 1, 
		  					'category_id' => null,
		    				'name' => 'AC - Posts', 
		    				'meta_title' => 'AC - Posts', 
		    				'slug' => 'ac/posts', 
		    				'lang_id' => null,
		    				'template' => 'ca_ac_default', 
		    				'created' => $now, 
		    				'modified' => $now),
		    	array('parent_id' => 1, 
		  					'category_id' => null,
		    				'name' => 'AC - Categorias', 
		    				'meta_title' => 'AC - Categorias', 
		    				'slug' => 'ac/categorias', 
		    				'lang_id' => null,
		    				'template' => 'ca_ac_default', 
		    				'created' => $now, 
		    				'modified' => $now),
		    	array('parent_id' => 1, 
		  					'category_id' => null,
		    				'name' => 'AC - Recuperar contraseña', 
		    				'meta_title' => 'AC - Recuperar contraseña', 
		    				'slug' => 'ac/recuperar-contrasena', 
		    				'lang_id' => null,
		    				'template' => 'ca_ac_password_recover', 
		    				'created' => $now, 
		    				'modified' => $now),
		    	array('parent_id' => 1, 
		  					'category_id' => null,
		    				'name' => 'AC - Restablecer contraseña', 
		    				'meta_title' => 'AC - Restablecer contraseña', 
		    				'slug' => 'ac/restablecer-contrasena', 
		    				'lang_id' => null,
		    				'template' => 'ca_ac_password_reset', 
		    				'created' => $now, 
		    				'modified' => $now),
		    	array('parent_id' => 1, 
		  					'category_id' => null,
		    				'name' => 'AC - Mi cuenta', 
		    				'meta_title' => 'AC - Mi cuenta', 
		    				'slug' => 'ac/usuario', 
		    				'lang_id' => null,
		    				'template' => 'ca_ac_default', 
		    				'created' => $now, 
		    				'modified' => $now),
		    	array('parent_id' => 1, 
		  					'category_id' => null,
		    				'name' => 'AC - Ayuda', 
		    				'meta_title' => 'AC - Ayuda', 
		    				'slug' => 'ac/ayuda', 
		    				'lang_id' => null,
		    				'template' => 'ca_ac_default', 
		    				'created' => $now, 
		    				'modified' => $now),
		    	/* Default public pages */
		   		array('parent_id' => null, 
		  					'category_id' => null,
		   					'name' => '404', 
		   					'meta_title' => '404', 
		   					'slug' => '404', 
		    				'lang_id' => null,
		   					'template' => '404', 
		   					'created' => $now, 
		   					'modified' => $now),
		    	array('parent_id' => null, 
		  					'category_id' => 1,
		    				'name' => 'Inicio', 
		    				'meta_title' => 'Inicio', 
		    				'slug' => 'inicio', 
		    				'lang_id' => 1,
		    				'template' => 'ca_template_home', 
		    				'created' => $now, 
		    				'modified' => $now),
		  		array('parent_id' => null, 
		  					'category_id' => 1,
		  					'name' => 'Blog', 
		  					'meta_title' => 'Blog', 
		  					'slug' => 'blog', 
		    				'lang_id' => 1,
		  					'template' => 'ca_template_blog', 
		  					'created' => $now, 
		  					'modified' => $now),
		  		array('parent_id' => null, 
		  					'category_id' => 1,
		  					'name' => 'Catálogo', 
		  					'meta_title' => 'Catálogo', 
		  					'slug' => 'catalogo', 
		    				'lang_id' => 1,
		  					'template' => 'ca_template_catalogue', 
		  					'created' => $now, 
		  					'modified' => $now),
		    );
		    $this->db->insert_batch($table, $data);
	    }
	    return $result;
		}

		/**
		 * Products
		 *
		 * @return [type] [description]
		 */
		private function _products()
		{
			/* Define table name */
			$table = config_item('ca_tables_prefix') . 'products';
			/**
			 * Define table fields
			 * 
			 * id
			 * author_id
			 * category_id
			 * brand_id
			 * related_products_id
			 * meta_title
			 * meta_description
			 * code
			 * name
			 * description
			 * measures
			 * weight
			 * size
			 * color
			 * price
			 * additionals
			 * slug
			 * template
			 * lang_id
			 * created
			 * modified
			 * status_id
			 * 
			 */
			$this->dbforge->add_field(
				array('id' => array('type' => 'INT', 'constraint' => 11, 'auto_increment' => TRUE),
							'author_id' => array('type' => 'INT', 'constraint' => 11, 'null' => FALSE, 'default' => 1),
					    'category_id' => array('type' => 'INT', 'constraint' => 11, 'null' => TRUE, 'default' => 3),
					    'brand_id' => array('type' => 'INT', 'constraint' => 11, 'null' => TRUE),
					    'related_products_id' => array('type' => 'VARCHAR', 'constraint' => 255, 'null' => TRUE),
					    'meta_title' => array('type' => 'VARCHAR', 'constraint' => 160, 'null' => TRUE),
					    'meta_description' => array('type' => 'VARCHAR', 'constraint' => 300, 'null' => TRUE),
					    'code' => array('type' => 'VARCHAR', 'constraint' => 255, 'null' => TRUE,),
					    'name' => array('type' => 'VARCHAR', 'constraint' => 255,),
					    'content' => array('type' => 'TEXT', 'null' => TRUE,),
					    'measures' => array('type' => 'VARCHAR', 'constraint' => 14, 'null' => TRUE,),
					    'weight' => array('type' => 'DECIMAL', 'constraint' => '10,2', 'null' => TRUE,),
					    'size' => array('type' => 'VARCHAR', 'constraint' => 3, 'null' => TRUE,),
					    'color' => array('type' => 'VARCHAR', 'constraint' => 20, 'null' => TRUE,),
					    'price' => array('type' => 'DECIMAL', 'constraint' => '10,2', 'null' => TRUE,),
					    'additionals' => array('type' => 'TEXT', 'null' => TRUE,),
					    'slug' => array('type' => 'VARCHAR', 'constraint' => 255,),
					    'template' => array('type' => 'VARCHAR', 'constraint' => 255, 'default' => 'ca_template_product',),
					    'lang_id' => array('type' => 'INT', 'constraint' => 1, 'default' => 1, 'null' => TRUE),
					    'created' => array('type' => 'DATETIME'),
					    'modified' => array('type' => 'DATETIME'),
					    'status_id' => array('type' => 'INT', 'constraint' => 1, 'default' => 1)
				)
			);
			/* Define primary key */
	    $this->dbforge->add_key('id', TRUE);
	    /* Create table */
	    $result = $this->dbforge->create_table($table, TRUE);
	    if ($result) {
		    //$now = date('Y-m-d H:i:s');
		    /* insert default data */
	    }
	    return $result;
		}

}