<?php
  defined('BASEPATH') OR exit('No direct script access allowed');
  /**
   * Content Assistant
   *
   * A kind of Headless CMS system build over the Codeigniter framework (http://codeigniter.com)
   *
   * @package   ContentAssistant
   * @author    A59327424 @ Codeinalab
   * @copyright 
   * @license   
   * @link      
   * @version   0.9.3
   */

  /**
   * Project migration model
   *
   * This model updates the Ca DB to customize the project: Yeguada La Reserva
   *
   * @todo Add project customizations
   */
  class Migration_Project_setup extends CI_Migration {

    /**
     * Up
     * Setup bootstrap
     *
     * @return boolean
     */
    public function up()
    {
      $this->_project_settings();
      $this->_project_categories();
      $this->_project_pages();
      $this->_project_products();
    }

  /**
   * Down
   * Setup reset
   *
   * @return boolean
   */
  public function down()
  {
    //$this->dbforge->drop_table('table');
  }

  /**
   * Project settings
   *
   * Update project settings
   */
  private function _project_settings()
  {
    $table = config_item('ca_tables_prefix') . 'settings';
    $now = date('Y-m-d H:i:s');

      $data = array(

        array(
          'id' => 1,
          'name' => 'project',
          'items' => serialize(
            array(
              'name' => array(
                'id' => 1,
                'value' => 'Yeguada La Reserva'
              ),
              'email' => array(
                'id' => 2,
                'value' => 'info@yeguadalareserva.mx'
              ),
              'email_cc' => array(
                'id' => 3,
                'value' => ''
              ),
              'email_bcc' => array(
                'id' => 4,
                'value' => ''
              ),
              'g_analytics_tracking_id' => array(
                'id' => 5,
                'value' => ''
              ),
              'g_recaptcha_site_key' => array(
                'id' => 6,
                'value' => ''
              ),
              'g_recaptcha_secret_key' => array(
                'id' => 7,
                'value' => ''
              ),
            )
          ),
          'modified' => $now
        ),

        array(
          'id' => 3,
          'name' => 'templates',
          'items' => serialize(
           array(
              'Default' => array(
                'id' => 1,
                'value' => 'default'
              ),
              'Home' => array(
                'id' => 2,
                'value' => 'home'
              ),
              'Blog' => array(
                'id' => 3,
                'value' => 'blog'
              ),
              'Post' => array(
                'id' => 4,
                'value' => 'post'
              ),
              'Catalogo' => array(
                'id' => 5,
                'value' => 'catalogue'
              ),
              'Productos' => array(
                'id' => 6,
                'value' => 'product'
              ),

              // New templates
              'Quiénes somos' => array(
                'id' => 6,
                'value' => 'about'
              ),
              'Distribuidores' => array(
                'id' => 6,
                'value' => 'dealers'
              ),
              'FAQs' => array(
                'id' => 6,
                'value' => 'faqs'
              ),
              'Contacto' => array(
                'id' => 6,
                'value' => 'contact'
              ),

            )
          ),
          'modified' => $now
        ),

        array(
          'id' => 8,
          'name' => 'products_image_sizes',
          'items' => serialize(
            array(
              'default' => array(
                'id' => 1,
                'value' => '1280,1280'
              ),
              'thumb' => array(
                'id' => 2,
                'value' => '240,240'
              ),
              'width_breakpoints' => array(
                'id' => 3,
                'value' => '1024,780'
              ),
            )
          ),
          'created' => $now,
          'modified' => $now
        ),

      );

      $this->db->update_batch($table, $data, 'id');
  }

  /**
   * Project categories
   *
   * Add new categories
   */
  private function _project_categories()
  {
    $table = config_item('ca_tables_prefix') . 'categories';
    $now = date('Y-m-d H:i:s');
      // Categories ID starts from 5

      // New categories
      // Product categories
      $data = array(
        array('parent_id' => 3, 
              'name' => 'Shampoo', 
              'slug' => 'shampoo', 
              'lang_id' => 1,
              'created' => $now, 
              'modified' => $now),
        array('parent_id' => 3, 
              'name' => 'Cremas y aceites', 
              'slug' => 'cremas-y-aceites', 
              'lang_id' => 1,
              'created' => $now, 
              'modified' => $now),
        array('parent_id' => 3, 
              'name' => 'Gel', 
              'slug' => 'gel', 
              'lang_id' => 1,
              'created' => $now, 
              'modified' => $now),
        array('parent_id' => 3, 
              'name' => 'Suplementos', 
              'slug' => 'suplementos', 
              'lang_id' => 1,
              'created' => $now, 
              'modified' => $now),
        array('parent_id' => 3, 
              'name' => 'Para caballeros', 
              'slug' => 'para-caballeros', 
              'lang_id' => 1,
              'created' => $now, 
              'modified' => $now),
        array('parent_id' => 3, 
              'name' => 'Productos Especiales', 
              'slug' => 'productos-especiales', 
              'lang_id' => 1,
              'created' => $now, 
              'modified' => $now),
        // Brands
        array('parent_id' => 4, 
              'name' => 'Yeguada La Reserva', 
              'slug' => 'Yeguada La Reserva', 
              'lang_id' => 1,
              'created' => $now, 
              'modified' => $now),
      );

      $this->db->insert_batch($table, $data);
  }

  /**
   * Project pages
   *
   * Add new pages
   */
  private function _project_pages()
  {
    $table = config_item('ca_tables_prefix') . 'pages';
    $now = date('Y-m-d H:i:s');
      // Pages ID starts from 16

      // New pages
      $data = array(
        array('parent_id' => null,
              'category_id' => 1,  
              'name' => 'Quiénes somos', 
              'meta_title' => 'Quiénes somos', 
              'slug' => 'quienes-somos', 
              'lang_id' => 1,
              'template' => 'ca_template_about', 
              'created' => $now, 
              'modified' => $now),
        array('parent_id' => null,
              'category_id' => 1,  
              'name' => 'Distribuidores', 
              'meta_title' => 'Distribuidores', 
              'slug' => 'distribuidores', 
              'lang_id' => 1,
              'template' => 'ca_template_dealers', 
              'created' => $now, 
              'modified' => $now),
        array('parent_id' => null,
              'category_id' => 1,  
              'name' => 'Preguntas frecuentes', 
              'meta_title' => 'Preguntas frecuentes', 
              'slug' => 'preguntas-frecuentes', 
              'lang_id' => 1,
              'template' => 'ca_template_faqs', 
              'created' => $now, 
              'modified' => $now),
        array('parent_id' => null,
              'category_id' => 1,  
              'name' => 'Contacto', 
              'meta_title' => 'Contacto', 
              'slug' => 'contacto', 
              'lang_id' => 1,
              'template' => 'ca_template_contact', 
              'created' => $now, 
              'modified' => $now),
        array('parent_id' => null,
              'category_id' => 1,  
              'name' => 'Aviso de privacidad', 
              'meta_title' => 'Aviso de privacidad', 
              'slug' => 'aviso-de-privacidad', 
              'lang_id' => 1,
              'template' => 'ca_template_default', 
              'created' => $now, 
              'modified' => $now),
        /*array('parent_id' => null,
              'category_id' => 1,  
              'name' => 'Términos y condiciones', 
              'meta_title' => 'Términos y condiciones', 
              'slug' => 'terminos-y-condiciones', 
              'lang_id' => 1,
              'template' => 'ca_template_default', 
              'created' => $now, 
              'modified' => $now),*/
      );

      $this->db->insert_batch($table, $data);
  }

  /**
   * Project products
   *
   * Add new products
   */
  private function _project_products()
  {
    $table = config_item('ca_tables_prefix') . 'products';
    $now = date('Y-m-d H:i:s');

      // New products
      $data = array(
        array('name' => 'Shampoo negro 1 l', 
              'meta_title' => 'Shampoo negro 1 l', 
              'slug' => 'catalogo/producto/shampoo-negro-1-l', 
              'brand_id' => 11, 
              'category_id' => 5,
              'status_id' => 2,
              'created' => $now, 
              'modified' => $now),
        array('name' => 'Colageno capilar', 
              'meta_title' => 'Colageno capilar', 
              'slug' => 'catalogo/producto/colageno-capilar', 
              'brand_id' => 11, 
              'category_id' => 6,
              'status_id' => 1,
              'created' => $now, 
              'modified' => $now),
        array('name' => 'Yegualash 15 ml', 
              'meta_title' => 'Yegualash 15 ml', 
              'slug' => 'catalogo/producto/yegualash-15-ml', 
              'brand_id' => 11, 
              'category_id' => 6,
              'status_id' => 2,
              'created' => $now, 
              'modified' => $now),
        array('name' => 'Shampoo verde 1 l', 
              'meta_title' => 'Shampoo verde 1 l', 
              'slug' => 'catalogo/producto/shampoo-verde-1-l', 
              'brand_id' => 11, 
              'category_id' => 5,
              'status_id' => 1,
              'created' => $now, 
              'modified' => $now),
        array('name' => 'Shampoo rojo 1 l', 
              'meta_title' => 'Shampoo rojo 1 l', 
              'slug' => 'catalogo/producto/shampoo-rojo-1-l', 
              'brand_id' => 11, 
              'category_id' => 5,
              'status_id' => 1,
              'created' => $now, 
              'modified' => $now),
        array('name' => 'Yeguaelixir 125 ml', 
              'meta_title' => 'Yeguaelixir 125 ml', 
              'slug' => 'catalogo/producto/yeguaelixir-125-ml', 
              'brand_id' => 11, 
              'category_id' => 6,
              'status_id' => 2,
              'created' => $now, 
              'modified' => $now),
        array('name' => 'Sales exfoliantes sil - bek', 
              'meta_title' => 'Sales exfoliantes sil - bek', 
              'slug' => 'catalogo/producto/sales-exfoliantes-sil-bek', 
              'brand_id' => 11, 
              'category_id' => 6,
              'status_id' => 1,
              'created' => $now, 
              'modified' => $now),
        array('name' => 'Gel criogénico de mentol', 
              'meta_title' => 'Gel criogénico de mentol', 
              'slug' => 'catalogo/producto/gel-criogenico-de-mentol', 
              'brand_id' => 11, 
              'category_id' => 7,
              'status_id' => 1,
              'created' => $now, 
              'modified' => $now),
        array('name' => 'Gel reduce termogénico de toronja', 
              'meta_title' => 'Gel reduce termogénico de toronja', 
              'slug' => 'catalogo/producto/gel-reduce-termogenico-de-toronja', 
              'brand_id' => 11, 
              'category_id' => 7,
              'status_id' => 1,
              'created' => $now, 
              'modified' => $now),
        array('name' => 'Shampoo y loción para barba 125 ml', 
              'meta_title' => 'Shampoo y loción para barba 125 ml', 
              'slug' => 'catalogo/producto/shampoo-y-locion-para-barba-125-ml', 
              'brand_id' => 11, 
              'category_id' => 9,
              'status_id' => 1,
              'created' => $now, 
              'modified' => $now),
        array('name' => 'Shampoo para perro', 
              'meta_title' => 'Shampoo para perro', 
              'slug' => 'catalogo/producto/shampoo-para-perro', 
              'brand_id' => 11, 
              'category_id' => 10,
              'status_id' => 1,
              'created' => $now, 
              'modified' => $now),
        array('name' => 'Shampoo sábila forte for men', 
              'meta_title' => 'Shampoo sábila forte for men', 
              'slug' => 'catalogo/producto/shampoo-sabila-forte-for-men', 
              'brand_id' => 11, 
              'category_id' => 9,
              'status_id' => 1,
              'created' => $now, 
              'modified' => $now),
        array('name' => 'Shampoo matizante de rubio', 
              'meta_title' => 'Shampoo matizante de rubio', 
              'slug' => 'catalogo/producto/shampoo-matizante-de-rubio', 
              'brand_id' => 11, 
              'category_id' => 5,
              'status_id' => 1,
              'created' => $now, 
              'modified' => $now),
        array('name' => 'Shampoo antipiojos y liendres ', 
              'meta_title' => 'Shampoo antipiojos y liendres ', 
              'slug' => 'catalogo/producto/shampoo-antipiojos-y-liendres ', 
              'brand_id' => 11, 
              'category_id' => 5,
              'status_id' => 1,
              'created' => $now, 
              'modified' => $now),
        array('name' => 'Mini shampoo negro', 
              'meta_title' => 'Mini shampoo negro', 
              'slug' => 'catalogo/producto/mini-shampoo-negro', 
              'brand_id' => 11, 
              'category_id' => 5,
              'status_id' => 1,
              'created' => $now, 
              'modified' => $now),
        array('name' => 'Mini shampoo verde', 
              'meta_title' => 'Mini shampoo verde', 
              'slug' => 'catalogo/producto/mini-shampoo-verde', 
              'brand_id' => 11, 
              'category_id' => 5,
              'status_id' => 1,
              'created' => $now, 
              'modified' => $now),
        array('name' => 'Mini shampoo rojo', 
              'meta_title' => 'Mini shampoo rojo', 
              'slug' => 'catalogo/producto/mini-shampoo-rojo', 
              'brand_id' => 11, 
              'category_id' => 5,
              'status_id' => 1,
              'created' => $now, 
              'modified' => $now),
        array('name' => 'Colágeno de bolsillo 60 g', 
              'meta_title' => 'Colágeno de bolsillo 60 g', 
              'slug' => 'catalogo/producto/colageno-de-bolsillo-60-g', 
              'brand_id' => 11, 
              'category_id' => 6,
              'status_id' => 2, 
              'created' => $now, 
              'modified' => $now),
        array('name' => 'Cápsulas de aguacate', 
              'meta_title' => 'Cápsulas de aguacate', 
              'slug' => 'catalogo/producto/capsulas-de-aguacate', 
              'brand_id' => 11, 
              'category_id' => 8,
              'status_id' => 1,
              'created' => $now, 
              'modified' => $now),
        array('name' => 'Crema corporal de aguacate', 
              'meta_title' => 'Crema corporal de aguacate', 
              'slug' => 'catalogo/producto/crema-corporal-de-aguacate', 
              'brand_id' => 11, 
              'category_id' => 6,
              'status_id' => 1,
              'created' => $now, 
              'modified' => $now),
        array('name' => 'Protector uv', 
              'meta_title' => 'Protector uv', 
              'slug' => 'catalogo/producto/protector-uv', 
              'brand_id' => 11, 
              'category_id' => 6,
              'status_id' => 1,
              'created' => $now, 
              'modified' => $now),
        array('name' => 'Pomadita', 
              'meta_title' => 'Pomadita', 
              'slug' => 'catalogo/producto/pomadita', 
              'brand_id' => 11, 
              'category_id' => 6,
              'status_id' => 1,
              'created' => $now, 
              'modified' => $now),
        array('name' => 'Vitamina e', 
              'meta_title' => 'Vitamina e', 
              'slug' => 'catalogo/producto/vitamina-e', 
              'brand_id' => 11, 
              'category_id' => 8,
              'status_id' => 0,
              'created' => $now, 
              'modified' => $now),
        array('name' => 'Agua de rosas sin astringentes', 
              'meta_title' => 'Agua de rosas sin astringentes', 
              'slug' => 'catalogo/producto/agua-de-rosas-sin-astringentes', 
              'brand_id' => 11, 
              'category_id' => 10,
              'status_id' => 0,
              'created' => $now, 
              'modified' => $now),
        array('name' => 'Agua micelar', 
              'meta_title' => 'Agua micelar', 
              'slug' => 'catalogo/producto/agua-micelar', 
              'brand_id' => 11, 
              'category_id' => 10,
              'status_id' => 0,
              'created' => $now, 
              'modified' => $now),
        array('name' => 'Biotina', 
              'meta_title' => 'Biotina', 
              'slug' => 'catalogo/producto/biotina', 
              'brand_id' => 11, 
              'category_id' => 8,
              'status_id' => 1,
              'created' => $now, 
              'modified' => $now),
        array('name' => 'Gel antibacterial 1 l', 
              'meta_title' => 'Gel antibacterial 1 l', 
              'slug' => 'catalogo/producto/gel-antibacterial-1-l', 
              'brand_id' => 11, 
              'category_id' => 7,
              'status_id' => 1, 
              'created' => $now, 
              'modified' => $now),
        array('name' => 'Gel antibacterial 125 ml', 
              'meta_title' => 'Gel antibacterial 125 ml', 
              'slug' => 'catalogo/producto/gel-antibacterial-125-ml', 
              'brand_id' => 11, 
              'category_id' => 7,
              'status_id' => 1,
              'created' => $now, 
              'modified' => $now),
        array('name' => 'Gel antibacterial 30 ml', 
              'meta_title' => 'Gel antibacterial 30 ml', 
              'slug' => 'catalogo/producto/gel-antibacterial-30-ml', 
              'brand_id' => 11, 
              'category_id' => 7,
              'status_id' => 1,
              'created' => $now, 
              'modified' => $now),
      );

      $this->db->insert_batch($table, $data);
  }

}