<?php
  /**
   * Content Assistant
   *
   * A kind of Headless CMS system build over the Codeigniter framework (http://codeigniter.com)
   *
   * @package   ContentAssistant
   * @author    A59327424 @ Codeinalab
   * @copyright 
   * @license   
   * @link      
   * @version   0.10.0
   */

  /**
   * Ca_language model
   *
   * Handles language, 
   * set the CA language variables in config and
   * loads the proper language file
   *
   * @todo
   */
	class Ca_language extends CI_Model 
	{

		public function __construct()
		{
    	parent::__construct();
    	$this->load();
		}

		/**
		 * Load/set language
		 */
		public function load()
		{
			if ($this->db->table_exists(config_item('ca_tables_prefix') . 'settings'))
			{

        /* Get available languages from DB 
         * set language variables in config with default values; 
         * first item on available langauges array */
				$available_languages = $this->ca_utility->settings_get(null, 'languages')[0];
				$this->config->set_item('ca_available_langs', $available_languages);
				$default_language = $available_languages['items'][array_keys($available_languages['items'])[0]];
				$default_language_id = $default_language['id'];
				$default_language_code = $default_language['value'];
				$this->config->set_item('ca_lang_id', $default_language_id);
				$this->config->set_item('ca_html_lang', $default_language_code);
				$selected_language_code = $default_language_code;

				// Check if project is set to be multilanguage
				if (1 < count($available_languages['items']))
				{
          // Check if language code is already in the uri
					$uri_language = $this->uri->segment(1);
					$selected_language_index = array_search($uri_language, array_column($available_languages['items'], 'value'));

          /* If language code exists in the uri 
           * and equals to any of the available languages array items 
           * then update config values */
					if (false !== $selected_language_index)
					{
						$selected_language = $available_languages['items'][array_keys($available_languages['items'])[$selected_language_index]];
						$selected_language_id = $selected_language['id'];
						$selected_language_code = $selected_language['value'];
						$this->config->set_item('ca_lang_id', $selected_language_id);
						$this->config->set_item('ca_lang', $selected_language_code);
						$this->config->set_item('ca_html_lang', $selected_language_code);
					}
					else 
					{
						if ('ac' == $this->uri->segment(1))
						{
							redirect(base_url($default_language_code . '/ac'), 'location', 303);
						}
						else
						{
							redirect(base_url($default_language_code), 'location', 303);
						}
					}
				}

        // load the proper langauge file
				$this->lang->load('ca', $selected_language_code);
			}
		}

	}