<?php
  defined('BASEPATH') OR exit('No direct script access allowed');
  /**
   * Content Assistant
   *
   * A kind of Headless CMS system build over the Codeigniter framework (http://codeigniter.com)
   *
   * @package   ContentAssistant
   * @author    A59327424 @ Codeinalab
   * @copyright 
   * @license   
   * @link      
   * @version   0.10.0
   */
  
  /**
   * Ca_product model
   *
   * All product related goes here
   *
   * @todo
   */
	class Ca_product extends CI_Model
	{

		public $result_code;
		public $result_message;

    /**
     * Get product data
     *
     * @param  integer $item_id Unique page ID, optional
     * @param  string  $category_id One or multiple ids in a string to be use on a where in statement eg. 1 or 1,3,2
     * @param  integer $brand_id
     * @param  integer $lang_id
     * @param  integer $status_id
     *
     * @return array
     *
     * @todo  Add a count of elements in cart/orders COUNT(DISTINCT t4.id) AS has_order_items
     */
    public function get($item_id, $category_id, $brand_id, $lang_id, $status_id)
    {
      $this->db->select('t1.*, 
                         t2.name AS category_name, t2.slug AS category_slug, 
                         t3.name AS author_name, t3.last_name AS author_last_name, t3.email AS author_email');
      // Where
      if ($item_id)
      {
        /* item_id can be a string starting with a number, so
           if it is then add an extra string at the begining as 
           an exception to avoid the mysql automatic type conversion in expression evaluation
           https://dev.mysql.com/doc/refman/5.7/en/type-conversion.html */
      if (!is_numeric($item_id)) { $item_id = 'null'.$item_id; }
        $this->db->where('t1.id', $item_id);
      }
      $categories_id = explode(',', $category_id);
      if ($category_id)
      {
        $this->db->where_in('t1.category_id', $categories_id);
      }
      if ($lang_id)
      {
        $this->db->where('t1.lang_id', $lang_id);
      }
      if ($status_id)
      {
        $this->db->where('t1.status_id', $status_id);
      }
      $this->db->join(config_item('ca_tables_prefix') . 'categories AS t2', 't1.category_id = t2.id', 'left')
               ->join(config_item('ca_tables_prefix') . 'users AS t3', 't1.author_id = t3.id', 'left')
               ->group_by('t1.id')
               ->order_by('t1.name', 'ASC');
      $query = $this->db->get(config_item('ca_tables_prefix') . 'products AS t1');
      $result = [];
      foreach ($query->result_array() as $row) {
        $row['additionals'] = !empty($row['additionals']) ? unserialize($row['additionals']) : null;
        
        // Images
        $main_image = $row['id'] . '_' . friendly_string_get($row['name']);
        $prefix = $row['id'] . '_';
        $folder = 'products';
        $row['main_image'] = $main_image;
        $all_images = $this->ca_utility->folder_files_get($folder, $prefix, 'png');

        // Use array_values to reset array indexes
        $images = array_values(array_diff($all_images, [$main_image]));
        $row['additional_images'] = $images;
        $result[] = $row;
      }
      return $result;
    }


	}